/*
 * This file contains an array of opcode lengths.
 * It is generated from opcodes.list.
 * 0-length means the opcode is variable length or unrecognized.
 */

#include "generated/javavm/include/opcodes.h"

const char CVMopcodeLengths[256] = {
    1,    /* opc_nop */
    1,    /* opc_aconst_null */
    1,    /* opc_iconst_m1 */
    1,    /* opc_iconst_0 */
    1,    /* opc_iconst_1 */
    1,    /* opc_iconst_2 */
    1,    /* opc_iconst_3 */
    1,    /* opc_iconst_4 */
    1,    /* opc_iconst_5 */
    1,    /* opc_lconst_0 */
    1,    /* opc_lconst_1 */
    1,    /* opc_fconst_0 */
    1,    /* opc_fconst_1 */
    1,    /* opc_fconst_2 */
    1,    /* opc_dconst_0 */
    1,    /* opc_dconst_1 */
    2,    /* opc_bipush */
    3,    /* opc_sipush */
    2,    /* opc_ldc */
    3,    /* opc_ldc_w */
    3,    /* opc_ldc2_w */
    2,    /* opc_iload */
    2,    /* opc_lload */
    2,    /* opc_fload */
    2,    /* opc_dload */
    2,    /* opc_aload */
    1,    /* opc_iload_0 */
    1,    /* opc_iload_1 */
    1,    /* opc_iload_2 */
    1,    /* opc_iload_3 */
    1,    /* opc_lload_0 */
    1,    /* opc_lload_1 */
    1,    /* opc_lload_2 */
    1,    /* opc_lload_3 */
    1,    /* opc_fload_0 */
    1,    /* opc_fload_1 */
    1,    /* opc_fload_2 */
    1,    /* opc_fload_3 */
    1,    /* opc_dload_0 */
    1,    /* opc_dload_1 */
    1,    /* opc_dload_2 */
    1,    /* opc_dload_3 */
    1,    /* opc_aload_0 */
    1,    /* opc_aload_1 */
    1,    /* opc_aload_2 */
    1,    /* opc_aload_3 */
    1,    /* opc_iaload */
    1,    /* opc_laload */
    1,    /* opc_faload */
    1,    /* opc_daload */
    1,    /* opc_aaload */
    1,    /* opc_baload */
    1,    /* opc_caload */
    1,    /* opc_saload */
    2,    /* opc_istore */
    2,    /* opc_lstore */
    2,    /* opc_fstore */
    2,    /* opc_dstore */
    2,    /* opc_astore */
    1,    /* opc_istore_0 */
    1,    /* opc_istore_1 */
    1,    /* opc_istore_2 */
    1,    /* opc_istore_3 */
    1,    /* opc_lstore_0 */
    1,    /* opc_lstore_1 */
    1,    /* opc_lstore_2 */
    1,    /* opc_lstore_3 */
    1,    /* opc_fstore_0 */
    1,    /* opc_fstore_1 */
    1,    /* opc_fstore_2 */
    1,    /* opc_fstore_3 */
    1,    /* opc_dstore_0 */
    1,    /* opc_dstore_1 */
    1,    /* opc_dstore_2 */
    1,    /* opc_dstore_3 */
    1,    /* opc_astore_0 */
    1,    /* opc_astore_1 */
    1,    /* opc_astore_2 */
    1,    /* opc_astore_3 */
    1,    /* opc_iastore */
    1,    /* opc_lastore */
    1,    /* opc_fastore */
    1,    /* opc_dastore */
    1,    /* opc_aastore */
    1,    /* opc_bastore */
    1,    /* opc_castore */
    1,    /* opc_sastore */
    1,    /* opc_pop */
    1,    /* opc_pop2 */
    1,    /* opc_dup */
    1,    /* opc_dup_x1 */
    1,    /* opc_dup_x2 */
    1,    /* opc_dup2 */
    1,    /* opc_dup2_x1 */
    1,    /* opc_dup2_x2 */
    1,    /* opc_swap */
    1,    /* opc_iadd */
    1,    /* opc_ladd */
    1,    /* opc_fadd */
    1,    /* opc_dadd */
    1,    /* opc_isub */
    1,    /* opc_lsub */
    1,    /* opc_fsub */
    1,    /* opc_dsub */
    1,    /* opc_imul */
    1,    /* opc_lmul */
    1,    /* opc_fmul */
    1,    /* opc_dmul */
    1,    /* opc_idiv */
    1,    /* opc_ldiv */
    1,    /* opc_fdiv */
    1,    /* opc_ddiv */
    1,    /* opc_irem */
    1,    /* opc_lrem */
    1,    /* opc_frem */
    1,    /* opc_drem */
    1,    /* opc_ineg */
    1,    /* opc_lneg */
    1,    /* opc_fneg */
    1,    /* opc_dneg */
    1,    /* opc_ishl */
    1,    /* opc_lshl */
    1,    /* opc_ishr */
    1,    /* opc_lshr */
    1,    /* opc_iushr */
    1,    /* opc_lushr */
    1,    /* opc_iand */
    1,    /* opc_land */
    1,    /* opc_ior */
    1,    /* opc_lor */
    1,    /* opc_ixor */
    1,    /* opc_lxor */
    3,    /* opc_iinc */
    1,    /* opc_i2l */
    1,    /* opc_i2f */
    1,    /* opc_i2d */
    1,    /* opc_l2i */
    1,    /* opc_l2f */
    1,    /* opc_l2d */
    1,    /* opc_f2i */
    1,    /* opc_f2l */
    1,    /* opc_f2d */
    1,    /* opc_d2i */
    1,    /* opc_d2l */
    1,    /* opc_d2f */
    1,    /* opc_i2b */
    1,    /* opc_i2c */
    1,    /* opc_i2s */
    1,    /* opc_lcmp */
    1,    /* opc_fcmpl */
    1,    /* opc_fcmpg */
    1,    /* opc_dcmpl */
    1,    /* opc_dcmpg */
    3,    /* opc_ifeq */
    3,    /* opc_ifne */
    3,    /* opc_iflt */
    3,    /* opc_ifge */
    3,    /* opc_ifgt */
    3,    /* opc_ifle */
    3,    /* opc_if_icmpeq */
    3,    /* opc_if_icmpne */
    3,    /* opc_if_icmplt */
    3,    /* opc_if_icmpge */
    3,    /* opc_if_icmpgt */
    3,    /* opc_if_icmple */
    3,    /* opc_if_acmpeq */
    3,    /* opc_if_acmpne */
    3,    /* opc_goto */
    3,    /* opc_jsr */
    2,    /* opc_ret */
    0,    /* opc_tableswitch */
    0,    /* opc_lookupswitch */
    1,    /* opc_ireturn */
    1,    /* opc_lreturn */
    1,    /* opc_freturn */
    1,    /* opc_dreturn */
    1,    /* opc_areturn */
    1,    /* opc_return */
    3,    /* opc_getstatic */
    3,    /* opc_putstatic */
    3,    /* opc_getfield */
    3,    /* opc_putfield */
    3,    /* opc_invokevirtual */
    3,    /* opc_invokespecial */
    3,    /* opc_invokestatic */
    5,    /* opc_invokeinterface */
    0,    /* opc_xxxunusedxxx */
    3,    /* opc_new */
    2,    /* opc_newarray */
    3,    /* opc_anewarray */
    1,    /* opc_arraylength */
    1,    /* opc_athrow */
    3,    /* opc_checkcast */
    3,    /* opc_instanceof */
    1,    /* opc_monitorenter */
    1,    /* opc_monitorexit */
    0,    /* opc_wide */
    4,    /* opc_multianewarray */
    3,    /* opc_ifnull */
    3,    /* opc_ifnonnull */
    5,    /* opc_goto_w */
    5,    /* opc_jsr_w */
    1,    /* opc_breakpoint */
    2,    /* opc_aldc_quick */
    3,    /* opc_aldc_w_quick */
    2,    /* opc_aldc_ind_quick */
    3,    /* opc_aldc_ind_w_quick */
    2,    /* opc_ldc_quick */
    3,    /* opc_ldc_w_quick */
    3,    /* opc_ldc2_w_quick */
    3,    /* opc_getfield_quick */
    3,    /* opc_putfield_quick */
    3,    /* opc_getfield2_quick */
    3,    /* opc_putfield2_quick */
    3,    /* opc_getstatic_quick */
    3,    /* opc_putstatic_quick */
    3,    /* opc_agetstatic_quick */
    3,    /* opc_aputstatic_quick */
    3,    /* opc_getstatic2_quick */
    3,    /* opc_putstatic2_quick */
    3,    /* opc_invokevirtual_quick */
    3,    /* opc_ainvokevirtual_quick */
    3,    /* opc_dinvokevirtual_quick */
    3,    /* opc_vinvokevirtual_quick */
    3,    /* opc_invokenonvirtual_quick */
    3,    /* opc_invokesuper_quick */
    3,    /* opc_invokestatic_quick */
    5,    /* opc_invokeinterface_quick */
    3,    /* opc_invokevirtualobject_quick */
    3,    /* opc_invokeignored_quick */
    3,    /* opc_new_quick */
    3,    /* opc_anewarray_quick */
    4,    /* opc_multianewarray_quick */
    3,    /* opc_checkcast_quick */
    3,    /* opc_instanceof_quick */
    3,    /* opc_invokevirtual_quick_w */
    3,    /* opc_getfield_quick_w */
    3,    /* opc_putfield_quick_w */
    1,    /* opc_nonnull_quick */
    3,    /* opc_agetfield_quick */
    3,    /* opc_aputfield_quick */
    3,    /* opc_invokestatic_checkinit_quick */
    3,    /* opc_getstatic_checkinit_quick */
    3,    /* opc_putstatic_checkinit_quick */
    3,    /* opc_agetstatic_checkinit_quick */
    3,    /* opc_aputstatic_checkinit_quick */
    3,    /* opc_getstatic2_checkinit_quick */
    3,    /* opc_putstatic2_checkinit_quick */
    3,    /* opc_new_checkinit_quick */
    1,    /* opc_exittransition */
    0,
    0,
    0,
    0,
    0,
    0,
};
