#
#  Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
#
#
#  @(#)defs_foundation.mk	1.33 00/11/21
#

#
# Multiple PROFILE_SRCDIR entries are not allowed yet.
#
PROFILE_SRCDIR = \
   $(CVM_SHAREROOT)/foundation/classes

#
# The following are the public classes in the Foundation specification.
#
PROFILE_PUBLIC_CLASSES += \
   java.io.CharArrayReader \
   java.io.CharArrayWriter \
   java.io.FilterReader \
   java.io.FilterWriter \
   java.io.LineNumberReader \
   java.io.PipedReader \
   java.io.PipedWriter \
   java.io.PushbackReader \
   java.io.RandomAccessFile \
   java.io.SequenceInputStream \
   java.io.StringReader \
   java.io.StringWriter \
   java.lang.Compiler \
   java.lang.UnknownError \
   java.net.Authenticator \
   java.net.ConnectException \
   java.net.HttpURLConnection \
   java.net.MulticastSocket \
   java.net.NoRouteToHostException \
   java.net.PasswordAuthentication \
   java.net.ServerSocket \
   java.net.Socket \
   java.net.SocketImpl \
   java.net.SocketImplFactory \
   java.net.URLDecoder \
   java.net.URLEncoder \
   java.security.AlgorithmParameters \
   java.security.AlgorithmParametersSpi \
   java.security.AlgorithmParameterGenerator \
   java.security.AlgorithmParameterGeneratorSpi \
   java.security.DigestInputStream \
   java.security.Identity \
   java.security.IdentityScope \
   java.security.InvalidAlgorithmParameterException \
   java.security.KeyFactory \
   java.security.KeyFactorySpi \
   java.security.KeyPair \
   java.security.KeyPairGenerator \
   java.security.KeyPairGeneratorSpi \
   java.security.KeyStore \
   java.security.KeyStoreException \
   java.security.KeyStoreSpi \
   java.security.SecureRandom \
   java.security.SecureRandomSpi \
   java.security.Signature \
   java.security.SignatureSpi \
   java.security.SignedObject \
   java.security.Signer \
   java.security.acl.Acl \
   java.security.acl.AclEntry \
   java.security.acl.AclNotFoundException \
   java.security.acl.Group \
   java.security.acl.LastOwnerException \
   java.security.acl.NotOwnerException \
   java.security.acl.Owner \
   java.security.acl.Permission \
   java.security.cert.CertificateExpiredException \
   java.security.cert.CertificateNotYetValidException \
   java.security.cert.CertificateParsingException \
   java.security.cert.X509CRL \
   java.security.cert.X509CRLEntry \
   java.security.cert.X509Certificate \
   java.security.cert.X509Extension \
   java.security.interfaces.DSAKey \
   java.security.interfaces.DSAKeyPairGenerator \
   java.security.interfaces.DSAParams \
   java.security.interfaces.DSAPrivateKey \
   java.security.interfaces.DSAPublicKey \
   java.security.interfaces.RSAKey \
   java.security.interfaces.RSAPrivateCrtKey \
   java.security.interfaces.RSAPrivateKey \
   java.security.interfaces.RSAPublicKey \
   java.security.spec.DSAParameterSpec \
   java.security.spec.DSAPrivateKeySpec \
   java.security.spec.DSAPublicKeySpec \
   java.security.spec.PKCS8EncodedKeySpec \
   java.security.spec.RSAKeyGenParameterSpec \
   java.security.spec.RSAPrivateCrtKeySpec \
   java.security.spec.RSAPrivateKeySpec \
   java.security.spec.RSAPublicKeySpec \
   java.security.spec.AlgorithmParameterSpec \
   java.security.spec.EncodedKeySpec \
   java.security.spec.InvalidKeySpecException \
   java.security.spec.InvalidParameterSpecException \
   java.security.spec.KeySpec \
   java.security.spec.X509EncodedKeySpec \
   java.text.Annotation \
   java.text.AttributedCharacterIterator \
   java.text.AttributedString \
   java.text.BreakIterator \
   java.text.CharacterIterator \
   java.text.CollationElementIterator \
   java.text.CollationKey \
   java.text.Collator \
   java.text.RuleBasedCollator \
   java.text.StringCharacterIterator \
   java.util.EventListener \
   java.util.EventObject \
   java.util.Observable \
   java.util.Observer \
   java.util.Timer \
   java.util.TimerTask \
   java.util.TooManyListenersException \
   java.util.jar.JarOutputStream \
   java.util.zip.Adler32 \
   java.util.zip.CheckedInputStream \
   java.util.zip.CheckedOutputStream \
   java.util.zip.Deflater \
   java.util.zip.DeflaterOutputStream \
   java.util.zip.GZIPInputStream \
   java.util.zip.GZIPOutputStream \
   java.util.zip.ZipOutputStream \
   javax.microedition.io.HttpConnection \

#
# These are the classes in the Foundation specification that
# get pulled in by the transitive closure of the supersetted Foundation
# class implementations.  They are exposed public APIs and should show
# up on the Foundation-only list in the spec.  They are mainly pulled in
# by the sun.security.provider.Policy class.
#
PROFILE_PUBLIC_CLASSES += \
   java.security.Certificate \
   java.security.KeyManagementException \
   java.security.PrivateKey \
   java.security.Principal \
   java.security.UnrecoverableKeyException \
   java.security.cert.CRL \
   java.security.cert.CRLException \
   java.security.cert.CertificateFactory \
   java.security.cert.CertificateFactorySpi

#
# And these are the implementation classes in the Foundation specification.
#
PROFILE_IMPL_CLASSES += \
   java.net.PlainSocketImpl \
   java.net.SocketInputStream \
   java.net.SocketOutputStream \
   java.text.CharacterBreakData \
   java.text.CollationRules \
   java.text.CompactByteArray \
   java.text.CompactCharArray \
   java.text.CompactIntArray \
   java.text.CompactShortArray \
   java.text.CompactStringArray \
   java.text.EntryPair \
   java.text.IntHashtable \
   java.text.LineBreakData \
   java.text.MergeCollation \
   java.text.Normalizer \
   java.text.PatternEntry \
   java.text.RBCollationTables \
   java.text.RBTableBuilder \
   java.text.SentenceBreakData \
   java.text.SimpleTextBoundary \
   java.text.SpecialMapping \
   java.text.TextBoundaryData \
   java.text.UnicodeClassMapping \
   java.text.WordBreakData \
   java.text.WordBreakTable \
   \
   sun.io.CharToByteASCII \
   sun.io.ByteToCharASCII \
   sun.io.CharToByteUTF8 \
   sun.io.ByteToCharUTF8 \
   sun.io.CharToByteUTF16 \
   sun.io.ByteToCharUTF16 \
   sun.io.CharToByteUnicode \
   sun.io.ByteToCharUnicodeBig \
   sun.io.ByteToCharUnicodeBigUnmarked \
   sun.io.ByteToCharUnicodeLittle \
   sun.io.ByteToCharUnicodeLittleUnmarked \
   sun.io.CharToByteUnicodeBig \
   sun.io.CharToByteUnicodeBigUnmarked \
   sun.io.CharToByteUnicodeLittle \
   sun.io.CharToByteUnicodeLittleUnmarked \
   sun.security.provider.SecureRandom \
   sun.security.provider.SeedGenerator \
   sun.security.provider.Sun \
   sun.security.provider.X509Factory \
   sun.misc.BASE64Encoder \
   sun.misc.Compare \
   sun.misc.GC \
   sun.misc.REException \
   sun.misc.Regexp \
   sun.misc.RegexpPool \
   sun.misc.RegexpTarget \
   sun.misc.Sort \
   sun.net.NetworkClient \
   sun.net.ProgressEntry \
   sun.net.ProgressData \
   sun.net.www.MeteredStream \
   sun.net.www.HeaderParser \
   sun.net.www.http.HttpClient \
   sun.net.www.protocol.http.AuthenticationInfo \
   sun.net.www.protocol.http.BasicAuthentication \
   sun.net.www.protocol.http.DigestAuthentication \
   sun.net.www.protocol.http.Handler \
   sun.net.www.protocol.http.HttpAuthenticator \
   sun.net.www.protocol.http.HttpURLConnection \
   sun.security.x509.AlgIdDSA \
   sun.security.x509.CRLExtensions \
   sun.security.x509.CRLNumberExtension \
   sun.security.x509.CRLReasonCodeExtension \
   sun.security.x509.X509CRLEntryImpl \
   sun.security.x509.X509CRLImpl \
   sun.security.pkcs.PKCS8Key \
   sun.security.provider.SHA \
   sun.security.provider.DSAPrivateKey \
   sun.security.provider.DSAPublicKey \
   sun.security.provider.DSA \
   sun.security.provider.DSAKeyPairGenerator \
   sun.security.provider.DSAKeyFactory \
   sun.security.provider.DSAParameters \
   sun.security.provider.DSAParameterGenerator \
   sun.security.provider.JavaKeyStore \
   sun.security.provider.KeyProtector \
   sun.security.provider.MD5 \
   \
   com.sun.cdc.io.j2me.socket.Protocol \
   \
   com.sun.cdc.io.InternalConnector \
   com.sun.cdc.io.j2me.http.Protocol \
   \
   com.sun.cdc.io.j2me.serversocket.Protocol \
   com.sun.cdc.io.j2me.UniversalFilterInputStream \
   com.sun.cdc.io.j2me.UniversalInputStream \
   com.sun.cdc.io.j2me.UniversalFilterOutputStream \

#
# Foundation classes are the public and the implementation classes
# combined
#
CLASSLIB_CLASSES += \
	$(PROFILE_PUBLIC_CLASSES) \
	$(PROFILE_IMPL_CLASSES)

CVM_SHAREOBJS += \
   Compiler.o \
   Adler32.o \
   RandomAccessFile.o \
   Deflater.o

CVM_TEST_CLASSES += \
   foundation.TimerThreadTest

ifeq ($(CVM_SERIALIZATION), true)
CVM_TEST_CLASSES += \
   foundation.SerializationTestClient \
   foundation.SerializationTestServer \
   foundation.SerializationTestObject
endif

#
# The name of the HTML file that is generated with the names of all public
# foundation classes.
#
JAVADOC_CLASSESLIST = $(INSTALLDIR)/javadoc/foundation-classes.index.html
