#
#  Copyright 1998-2000 Sun Microsystems, Inc. All Rights Reserved.
#
#
#  @(#)config_vxworks.mk	1.14 00/11/08
#
# configurable definitions for VxWorks target
#

#
# Define the variables needed by tornado2 tools.
#

# Where to find the JDK
export JDK_HOME		= /usr/local/java/jdk1.3/solaris

# Define absolute top for reference from outside the workspace. Note this
# assumes the cwd is build/vxworks; be careful if ABSOLUTE_TOP is not
# defined and you invoke this makefile from a different directory level.

ifndef ABSOLUTE_TOP
export ABSOLUTE_TOP := $(shell cd ../.. ; pwd)
endif

# WIND_BASE determines where the Tornado installation lives.
ifndef WIND_BASE
#export WIND_BASE	= $(ABSOLUTE_TOP)/../tornado2
export WIND_BASE	= /micro/tornado2
endif

# WIND_HOST_TYPE determines which host architecture to use for executables.
ifndef WIND_HOST_TYPE
export WIND_HOST_TYPE	= sun4-solaris2
endif

# This points to the Tornado project directory - not to be confused with the
# Tornado installation base directory in WIND_BASE. Override this if you have
# your own project direcotory.
export TORNADO2DIR	= $(ABSOLUTE_TOP)/build/vxworks/target/PC

# The := operator expands PATH exactly once to prepend to PATH without
# recursion.  The += operator appends to the PATH.
export PATH		:= $(WIND_BASE)/host/$(WIND_HOST_TYPE)/bin:$(PATH)
export LD_LIBRARY_PATH 	:= $(WIND_BASE)/host/$(WIND_HOST_TYPE)/lib:$(LD_LIBRARY_PATH)
# This must be an absolute path to a version of libgcc.a compiled without -pic
# for vxworks.  See docs for more details on how to get the binary.
export LIB_GCC		= $(ABSOLUTE_TOP)/src/vxworks/lib/libgcc.a

# These must be set for the hard-target and host being used.
ETHER			= elPci
STARTUP			= $(HOME)/.wind/startup
TARGET_ADDR		= 192.168.151.118
HOST_ADDR		= 192.168.151.117
HOSTNAME		= thehost

# Where to find the floppy disk device on the host machine.
DISK_DEVICE = /vol/dev/diskette0/unnamed_floppy
MOUNTED_DISK = /floppy/floppy0
