'\" t
.so wrs.an
.\" pc/target.nr - PC386/486/Pentium/PentiumPro target-specific documentation
.\"
.\" Copyright 1984-1999 Wind River Systems, Inc.
.\"
.\" @(#)target.nr	1.1 00/04/18
.\"
.\" modification history
.\" --------------------
.\" 02b,12mar99,cn   added el3c90xEnd driver comment.
.\" 02a,11mar99,sbs  added ne2000End driver comment.
.\" 01z,11mar99,sbs  added ultraEnd driver comment.
.\" 01y,24feb99,hdn  added comment for Pentium/PentiumPro's data cache mode.
.\" 01x,01feb99,jkf  added 3com and AMD SENS support comment.
.\" 01w,26jan99,jkf  added INCLUDE_ADD_BOOTMEM information. (SPR#21338)
.\" 01v,04jun98,hdn  added PentiumPro's APIC support
.\" 01u,12may98,hdn  added Pentium/PentiumPro support
.\" 01t,01may98,yp   added TrueFFS support
.\" 01s,23mar98,ms-  rewritten to conform with guidlines in BSP developers kit
.\" 01r,12mar98,sbs  changed info on use of SCSI-2 driver.
.\" 01q,20nov97,map  mention no support for ISA PnP. [SPR# 9877]
.\" 01p,10jul97,dds  added info on use of the SCSI-2 driver for the AHA 2940
.\"                  PCI SCSI Adapter card.
.\" 01o,25feb97,mas  added info on use of mkboot/mkbootFd and reboot device
.\"		     selection using sysWarmType as well as info on the mapping
.\"		     of IRQ numbers to IRQ levels (SPR 7850).
.\" 01n,22nov96,dat  doc cleanup, added EtherExpress PRO100B support.
.\" 01m,01nov96,hdn  added support for PCMCIA.
.\" 01l,09sep96,hdn  added support for compression.
.\" 01k,26jul96,hdn  added support for ATA and SMC91c9x driver.
.\" 01j,19jun96,wlf  doc: cleanup.
.\" 01i,23oct95,jdi  doc: updated for Tornado
.\" 01h,28sep95,hdn  cleaned up.
.\" 01g,03aug95,myz  upgraded to 5.3 
.\" 01f,06jun94,hdn  added changes by Roland for 5.1.1 FCS.
.\" 01e,13may94,hdn  updated to 5.1.1 FCS.
.\" 01d,01dec93,hdn  cleaned up.
.\" 01c,09nov93,vin  upgraded to 5.1
.\" 01b,26mar93,hdn  added a description about boot rom image.
.\" 01a,12jan93,hdn  written.
.\"
.\" NOTE
.\" EXOS
.\"
.TH "pc386/486" T "PC 386/486" "Rev: 25 Mar 98" "TORNADO REFERENCE: VXWORKS"

.SH "NAME"
.aX "PC 386/486/PENTIUM/PENTIUMPRO"

.SH "INTRODUCTION"
This manual entry provides board-specific information 
necessary to run VxWorks for the pc386, pc486, pcPentium and
pcPentiumpro BSPs. 
Before using a board with VxWorks, verify that the board 
runs in the factory configuration by using vendor-supplied 
ROMs and jumper settings and checking the RS-232 connection.

Please note that the pc386, pc486, pcPentium and pcPentiumpro BSPs
are generic BSPs for generic PC-AT style motherboards. 
For best results, the board vendor's documentation should be used
in conjunction with this document.

.SS "TrueFFS support"
This BSP supports the optional product TrueFFS for Tornado. To use TrueFFS
install the product, add sysTffs.o to MACH_EXTRA in the Makefile and define
INCLUDE_TFFS or INCLUDE_PCMCIA in config.h.

Defining INCLUDE_PCMCIA assumes that TrueFFS support is needed.

TrueFFS is set up to use the M-Systems DiskOnChip 2000 and two PCMCIA
slots as a drive for use with dosFs.

If you wish to reboot from the DiskOnChip device change the finition for
SYS_WARM_TYPE in config.h from SYS_WARM_FD to SYS_WARM_TFFS.

.SS "BOOT ROMS"
The PC-AT generic boards use a boot diskette instead of boot ROMs. 
The boot diskette includes the boot sector (sector 0) and a DOS file system
containing a boot ROM image named `bootrom.sys'.
The boot ROM image could be one of following:

.TS E
expand;
c c c c
c c c c
l l l l.
		Image is	Image Loads
Image Name	Description	Compressed	Into
=
vxWorks_rom	bootable vxWorks	No	High Memory
vxWorks_rom_low	bootable vxWorks	No	Low Memory
vxWorks.st_rom	bootable vxWorks.st	Yes	High Memory
bootrom	bootrom	Yes	Low Memory
bootrom_uncmp	bootrom	No	Low Memory
bootrom_high	bootrom	Yes	High Memory
_
.TE

VxWorks.st is a fully linked stand alone image which 
includes a target based shell, symbol table, and network 
interface. Note that the network interface is not initialized.

The boot ROM image must be copied into the floppy disk (a:) or 
the IDE disk (c:) using the DOS boot utility "mkboot.bat" or the 
VxWorks boot utilities "mkbootFd" for floppy disks or 
"mkbootAta" for hard disks. 

For TrueFFS disks that appear as a hard disk using BIOS extentions 
the boot utility is "mkbootTffs".

The usage of the three VxWorks boot utilities is as follows:
.ne 15
.CS
STATUS mkbootFd
    (
    int drive,    /* destination drive number: (0 - 3)  */
    int fdType,   /* type of floppy disk: (0 - 1)       */
    char *in      /* source file name                   */
    )

STATUS mkbootAta 
    (
    int ctrl,     /* dest. controller number: (0 - 1)   */
    int drive,    /* dest. drive number: (0 - 1)        */
    char *in      /* source file name                   */
    )

STATUS mkbootTffs
    (
    int drive,       /* drive number: (0 - TFFS_MAX_DRIVES - 1) */
    int removable,   /* removable or not: (TRUE - FALSE)      */
    char *in         /* name of file to read: "bootrom_uncmp" */
    )
.CE
All routines return OK on success and ERROR if there is an error while
copying the image from the source onto the disk.

EXAMPLES:

Example 1: Creating a boot floppy disk using mkbootFd:

The floppy disk is in drive 0 (or a:), the diskette is of type 0,
and the image file name is `bootrom_uncmp':
.CS
    -> mkbootFd 0, 0, "bootrom_uncmp"
.CE
Example 2: Creating a bootable hard disk using mkbootFd:

The hard disk is on ATA controller 0 and is drive number 0
(or c:). The image file name is `bootrom_uncmp':
.CS
    -> mkbootAta 0, 0, "bootrom_uncmp"
.CE
Example 3: Creating a bootable TrueFFS disk using mkbootTffs:

The TrueFFS disk is drive 0 (or c:), that is a non removable drive.
The image file name is `bootrom_uncmp':
.CS
    -> mkbootTffs 0, 0, "bootrom_uncmp"
.CE

These boards do not have non-volatile RAM; thus, boot parameters are not
preserved whenever the system is powered off.  However, static boot
parameters can be set in the boot disk by setting the boot parameter line
DEFAULT_BOOT_LINE in config.h.

For information on the use of the DOS utility "mkboot.bat" and how to boot VxWorks,
please refer to the
.I "VxWorks Programmer's Guide, Appendix D: Intel i386/i486."

To load VxWorks, and for more information, follow the instructions in the
.I "Tornado User's Guide: Getting Started."

The config.h macro INCLUDE_ADD_BOOTMEM is used to memAddToPool some upper 
memory to a x86 low memory rom image.  VxWorks low memory rom images 
run within a memory range from 0x8000 to 0xa0000.  This restricts the 
size of the bootrom kernels memory pool available to drivers.  This 
macro is used to make upper memory (above 1MB) available to drivers
for the bootrom image only. It is defined in config.h and used in 
sysLib.c, sysHwInit2().   It should be un-defined for x86 systems with 
memory less than 4MB.  The default value is 0x00200000 (2MB).  This 
value may be increased, but beware that the added pool does not 
overlap with the downloaded vxWorks image.  If there is an overlap, 
then loading the vxWorks runtime image will corrupt the added 
memory pool.
 
To calculate the safe amount:
 
.CS
 (RAM_LOW_ADRS + vxWorks image size) < (memTopPhys + ADDED_BOOTMEM_SIZE)
.CE
 
Where: RAM_LOW_ADRS == 0x00108000 and memTopPhys is from sysLib.c.


.SS "Jumpers"
Refer to the board vendor's documentation.

.SH "FEATURES"
Since this is a generic BSP for generic PC-AT style motherboards,
your board may or may not have all of these features, and your
board may have some features not discussed here.
Your board vendor's documentation should be used in conjunction 
with this section.

.SS "Supported Features"
Supported features are discussed below in the "Devices" section
under the "HARDWARE DETAILS" heading.

.SS "Unsupported Features"

This BSP does not support ISA PnP. Such devices can be supported if
PnP is disabled and the device parameters (IO address, Memory address,
IRQ, DMA channel etc) are set to match those in the
BSP driver configuration. If
the device uses soft-configuration instead of jumpers, an appropriate
utility program, usually available from the device manufacturer,
should be used to set the device parameters.

.SS "Feature Interactions"
Refer to the board vendor's documentation.

.SH "HARDWARE DETAILS"
This section documents the details of the device drivers and board
hardware elements.

.SS "Devices"
Drivers included with this BSP are for both on-board chips
and for separate adaptor cards that can be used with the
motherboard.
Refer to the vendor's documentation for both the motherboard and
any adaptor cards used. Vendor documentation for on-board
chips may be necessary also.

Note that for all ISA drivers, the I/O base address,
memory address, and interrupt level must match those in config.h
or pc.h.

In the table below, drivers ending in the .c extension are
delivered in source form; the other drivers are delivered
in object form only.
    
.TS
center;
l l.
i8250Sio.c	Intel UART tty driver
i8237Dma.c	8237 DMA driver
pcConsole.c	console driver
i8042Kbd.c	Intel keyboard controller
i8048Kbd.c	Intel keyboard controller
m6845Vga.c	Motorola M6845 VGA controller
nec765Fd.o	nec765 floppy disk controller
ataDrv.o	IDE/ATA hard disk controller
ataShow.o	IDE/ATA hard disk controller show routines
aic7880Lib.o	AHA-2940 PCI SCSI Adapter card
i8253Timer.c	Intel 8253 timer driver
loApicTimer.c	Intel PentiumPro's Local APIC Timer driver
i8259Intr.c	Intel 8259 PIC
loApicIntr.c	Intel PentiumPro's Local APIC
ioApicIntr.c	Intel PentiumPro's IO APIC
nullNvRam.c	null NVRAM library
nullVme.c	null VMEbus library
pcmciaLib.o	PCMCIA driver
pcmciaShow.o	PCMCIA driver show routine
if_ultra.o	SMC Elite16 network interface driver
if_eex.o	Intel EtherExpress16 network interface driver
if_elt.o	3Com EtherLinkIII network interface driver
if_ene.o	Novell/Eagle 2000 network interface driver
if_esmc.o	Ampro Ethernet2(SMC 91c9x chip) network interface driver
if_fei.o	EtherExpress PRO100B network interface driver
fei82557End.o   EtherExpress PRO100B END/SENS driver
ln97xEnd.o      AMD Am79C97X PCnet-FAST PCI END/SENS driver
elt3c509End.o   3COM 3C509 END/SENS driver
el3c90xEnd.o    3COM 3C90x END/SENS driver
ultraEnd.o      SMC Elite Ultra END driver
if_ene.o	Novell/Eagle 2000 END driver
.TE

Below are some brief notes on each driver.
For more details refer to the
entry for each driver in the Libraries section of the 
.I "VxWorks Reference Manual"

.IP "i8250Sio"
Intel 8250 Universal Asynchronous 
Receiver Transmitter (UART) tty driver.
Used for the serial ports
.IP "i8237Dma"
Driver for the ISA DMA controller.
This is used in nec765Fd.c, which also
serves as a good application example.
.IP "pcConsole, i8042Kbd and i8048Kbd"
Driver for the on-board Intel 8042 and 8048 keyboard controllers
To use these controllers
the INCLUDE_PC_CONSOLE directive must be enabled in config.h.  
The macro
PC_KBD_TYPE should be defined in config.h as PC_PS2_101_KBD to include
i8042Kbd.c, and as PC_XT_83_KBD to include i8048Kbd.c.
.IP "m6845Vga"
Driver for the Motorola M6845 VGA controller.
To use this controller, define INCLUDE_PC_CONSOLE in config.h.
.IP "nec765Fd:
Driver for the nec765 floppy disk controller.
To use this driver, the INCLUDE_FD directive must be enabled in
config.h.
.IP "ataDrv and ataShow"
Driver for the IDE/ATA hard disk controller.  
To use this driver, the INCLUDE_ATA directive must be enabled in config.h. 
Note that the old INCLUDE_IDE directive is replaced by INCLUDE_ATA,
and that vxsys() is replaced by mkbootFd() and mkbootAta().
.IP "aic7880Lib"
A device driver for the  AHA-2940 PCI SCSI Adapter card is provided. This card
houses the AIC-7880 Adaptec SCSI Host Adapter. The macros, INCLUDE_SCSI 
and INCLUDE_SCSI2, must be defined in config.h in order to configure SCSI-2. 
This is a PCI card and INCLUDE_PCI must also be defined in config.h.

The SCSI-2 driver for x86 requires the AHA-2940 PCI SCSI Adapter card. The 
user is expected to follow instructions on the "Adaptec 7800 Family Manager 
Set User's Guide" regarding installation procedures. 

The default Interupt Request (IRQ) Channel number used by x86 BSP for
the SCSI interrupt is 0x0a. This may conflict with other interrupts in
the system (Eg. Ethernet). The user can change the macro SCSI_INT_LVL
in file "pc.h" to reflect an interrupt level number that does not conflict 
with the rest of the system interupts. For setting the IRQ number for
the SCSI Host  Adapter the user is recommended to enter the CMOS setup menu.

If SCSI configuration fails, it can be the result of improper SCSI bus 
termination. Check your hardware setup.

For information regarding installing the AHA-2940
see the "Adaptec 7800 Family Manager Set User's Guide".
.IP "i8253Timer"
This library contains routines to manipulate the timer functions on the
Intel 8253 chip with a board-independent interface.  This library handles
both the system clock and the auxiliary clock functions.
.IP
The macros SYS_CLK_RATE_MIN, SYS_CLK_RATE_MAX, AUX_CLK_RATE_MIN, and
AUX_CLK_RATE_MAX must be defined to provide parameter checking for the
sys[Aux]ClkRateSet() routines.
.IP
The macro PIT_CLOCK must also be defined to indicate the clock frequency
of the i8253.
.IP
The system clock is the programmable interrupt timer.
The auxiliary clock is the real time clock.
.IP
This driver includes a timestamp driver; to use this
feature, the macro INCLUDE_TIMESTAMP must be defined in config.h.
.IP "loApicTimer"
This library contains routines to manipulate the timer functions on the
Intel PentiumPro's Local APIC Timer with a board-independent interface.
This library handles both the system clock and the auxiliary clock 
functions.  The auxiliary clock is either the RTC (real time clock) or
PIT (programmable interrupt timer) channel 0 (define PIT0_FOR_AUX in 
config.h).
.IP
The macros SYS_CLK_RATE_MIN, SYS_CLK_RATE_MAX, AUX_CLK_RATE_MIN, and
AUX_CLK_RATE_MAX must be defined to provide parameter checking for the
sys[Aux]ClkRateSet() routines.
.IP
The macro TIMER_CLOCK_HZ must also be defined to indicate the clock 
frequency of the Local APIC Timer.
.IP
This driver includes a timestamp driver; to use this
feature, the macro INCLUDE_TIMESTAMP must be defined in config.h.
.IP "i8259Intr"
Driver for the Intel 8259A Programmable Interrupt Controller (PIC).
.IP "loApicIntr"
Driver for the Intel PentiumPro's Local APIC.
This driver is used in either Virtual Wire Mode (define VIRTUAL_WIRE_MODE
in config.h) or Symmetric IO Mode (define SYMMETRIC_IO_MODE in config.h).
loApicInit () initializes the Local APIC and scans certain memory
regions as specified in the specification to determine the base
addresses.  It uses LOAPIC_BASE and IOAPIC_BASE defined in the BSP, if
it is not able to find the addresses in the MP configuration table.
Scaned memory regions are defined by two pairs of macro in pc.h,
BIOS_ROM_START and BIOS_ROM_END, EBDA_START and EBDA_END.
.IP "ioApicIntr"
Driver for the Intel IO APIC.
This driver is used in Symmetric IO Mode (define SYMMETRIC_IO_MODE in
config.h).  ioApicInit() initializes the IO APIC with information stored
in redTable[].  redTable[] has three entries - lsw, vectorNo, mask.  
First entry, lsw, stores the least significant word of the IO APIC's 
redirection table.  That includes Trigger Mode, Interrupt Input Pin 
Polarity, Destination Mode, Delivery Mode.  Second entry, vectorNo, is
the vectorNo of the redirection table.  Third entry, mask, should be 0 
and used by ioApicIntLock() and ioApicIntUnlock() to hold the interrupt
mask status.
.IP "nullNvRam"
This library contains dummy non-volatile RAM manipulation routines for targets
lacking non-volatile RAM.  Read and write routines that return ERROR
are included.

The macro NV_RAM_SIZE should be defined as NONE for targets lacking
non-volatile RAM.
.IP "nullVme"
This library contains null routines for boards which do not include any
common bus routines.
.IP "pcmciaLib and pcmciaShow"
Drivers for PCMCIA. In order to use any PCMCIA card 
the INCLUDE_PCMCIA directive
must be enabled in config.h. These drivers currently
support three cards. To use an ATA PC card, enable
INCLUDE_ATA; to use an SRAM PC card, enable INCLUDE_SRAM;
to use a 3COM Etherlink III PC card, enable INCLUDE_ELT.
By default, all three cards are enabled when INCLUDE_PCMCIA is enabled.
.IP "if_ultra"
Driver for the SMC Elite16 (Western Digital 8013WC) 
and SMC Elite 16 Ultra network cards.
To use these controllers the INCLUDE_ULTRA 
directive must be enabled in config.h.  
The following jumper configurations
are supported:

.TS
center;
cf3 s cf3 s
lf3 lf3 lf3 lf3
c c c c
a a4 a a .
SMC Elite 16		SMC Elite16 Ultra
Jumper	Setting	Jumper	Setting
_
W1	SOFT (I/O addr 0x240)	W1	SOFT (I/O addr 0x240)
W2	NONE/SOFT	-	NO ROM
-	NO ROM
_
.TE

IRQ levels 2,3,5,7,10,11,15 are supported.
.IP "if_eex"
Driver for the Intel EtherExpress16 network card.  
To use this board the INCLUDE_EEX 
directive must be enabled in config.h.  
This board is soft-configured with no jumpers.
.IP "if_elt"
Driver for the 3Com EtherLinkIII network card.
To use this board the INCLUDE_ELT
directive must be enabled in config.h.  
This board is 
soft-configured with no jumpers.
PnP must be disabled in the soft configuration for this card
to work with vxWorks.
.IP "if_ene"
Driver for several compatible versions of the 
Novell/Eagle 2000.
To use one of these board the INCLUDE_ENE
directive must be enabled in config.h.  
The I/O base address, 
memory address, and interrupt level must match those in config.h.
.IP "if_esmc"
Driver for the
Ampro Ethernet2(SMC 91c9x chip) network card.
To use this board the INCLUDE_ESMC
directive must be enabled in config.h.  
This board is soft configured.
The I/O base address and interrupt level must match those in config.h.
.IP "if_fei"
Generic driver for the
Intel 82557 Ethernet network interface chip.
An example of a board using this chip is 
the EtherExpress PRO100B. 
To use this driver the INCLUDE_FEI
directive must be enabled in config.h.
If defined FEI_10MB indicates
the unit should operate at ethernet speed of 10 megabits per second.

.SS "Memory Maps"
.TS
center allbox;
c c c
l l l.
Start Address	Size	Use
LOCAL_MEM_LOCAL_ADRS	0xa0000	lower memory
0xa0000	0x60000	video ram, etc
0x100000	LOCAL_MEM_SIZE - 0x100000	upper memory
.TE

.SS "Shared Memory"
Not applicable to this BSP

.SS "Interrupts"
All ISA interrupts are external to the CPU and are routed
through the ISA interrupt prioritization hardware.  This hardware is
comprised of two 82C59 PICs.  There are 16 ISA interrupts and
interrupt priority levels numbered 0 through 15. The mapping between
interrupt numbers and priority levels is not necessarily one to one.
The motherboard hardware determines the mapping of interrupt
request lines (IRQ) to priority levels. The hardware should
adhere to the standard ISA assignments:

.ne 18 
            IRQ         Priority
            ---         --------
             0              0
             1              1
             2              2
             3             11
             4             12
             5             13
             6             14
             7             15
             8              3
             9              4
            10              5
            11              6
            12              7
            13              8
            14              9
            15             10

IRQs 0 - 7 are handled by PIC1 and IRQs 8 - 15 by PIC2.  PIC2 interrupts are
cascaded into PIC1 at IRQ2 which is reflected in the above table.

PentiumPro has new interrupt controller APIC (Advanced Programmable Interrupt
Controller) which consists of Local APIC (on-chip) and IO APIC (on chipset).
They are used in two additional interrupt modes that are configurable in BSP.  

Virtual Wire Mode: One of three interrupt modes defined by the MP
specification.  In this mode, interrupts are generated by the 8259A 
equivalent PICs, but delivered to the BSP by an APIC that is programmed to 
act as a "virtual wire"; that is, the APIC is logically indistinguishable 
from a hardware connection.  This is a uniprocessor compatibility mode.
To use this mode, define VIRTUAL_WIRE_MODE in config.h

Symmetric IO Mode: One of three interrupt modes defined by the MP
specification.  In this mode, the APICs are fully functional, and 
interrupts are generated and delivered to the processors by the APICs.  
Any interrupt can be delivered to any processor.  This is the only 
multiprocessor interrupt mode.
To use this mode, define SYMMETRIC_IO_MODE in config.h

.SS "Serial Configuration"
Refer to the board vendor's documentation.

.SS "SCSI Configuration"
Refer to the board vendor's documentation.

.SS "Network Configuration"
Refer to the board vendor's documentation.

.SS "VME Access"
This BSP has no VME access

.SS "PCI Access"
In order to use PCI the INCLUDE_PCI
directive must be enabled in config.h.
Furthermore, PCI_CFG_TYPE in pc.h
must be set to the correct configuration type.
Values for PCI_CFG_TYPE must be one of:

.TS
center;
c c
l l.
Macro	meaning
_
PCI_CFG_FORCE	force user specified configuration
PCI_CFG_AUTO	VxWorks does auto configuration. Currently unavailable.
PCI_CFG_NONE	external agent does configuration
.TE

PCI defines two mechanisms. The newer method, and the default vxWorks
method, is PCI_MECHANISM_1. Some older PCs might work better with
the old method, PCI_MECHANISM_2. If PCI is not working with
your older PC, change the first argument to pciIomapLibInit
to PCI_MECHANISM_2 in sysLib.c:
.ne 7
.CS
#ifdef  INCLUDE_PCI
    pciIomapLibInit (PCI_MECHANISM_1, PCI_CONFIG_ADDR, PCI_CONFIG_DATA,
NONE);
#if     FALSE
    pciIomapLibInit (PCI_MECHANISM_2, PCI_CONFIG_CSE, PCI_CONFIG_FORWARD,
                     PCI_CONFIG_BASE);
#endif  /* FALSE */
.CE
.ne 22
.SS "Boot Devices"
The supported boot devices are:
	
.CS
    \f3xx\f1 - Ethernet (any one of the many adaptors described above)
.CE
.CS
    \f3pcmcia=<slot number>\f1 - PCMCIA device
        slot number is one of:
            0 = PCMCIA slot 0
            1 = PCMCIA slot 1
	Note: Supported PCMCIA boot cards are the 3COM Etherlink III PC card
	and a PCMCIA ATA card
.CE
.CS
    \f3fd=<drive number>,<diskette type>\f1 - Diskette
        drive number is one of:
            0 = default; the first diskette drive (drive A:)
            1 = the second diskette drive (drive B:)
        diskette type is one of:
            0 = default; 3.5" diskette
            1 = 5.25" diskette
.CE
.CS
    \f3ata=<controller number>,<drive number>\f1 - ATA/IDE drive
        controller number is one of:
            0 = controller described in the first entry of 
                the ataResources table
            1 = controller described in the second entry of 
                the ataResources table
        drive number is one of:
            0 = first drive on the controller
            1 = second drive on the controller
.CE
Note: 
By default, with INCLUDE_ATA, vxWorks is set up for 
one ATA hard disk device on the primary ATA controller.  
The 2nd hard disk on the primary controller and the 
secondary controller are normally disabled to prevent timeouts.
If you have multiple controllers and/or hard disks
you must modify the ataResources structure array in sysLib.c to support 
more drives.

.ne 34
Example:
Two controllers, each with two drives (4 drives total):
.CS
ATA_RESOURCE ataResources[ATA_MAX_CTRLS] =
    {
        {
            {
                5, 0,
                {ATA0_IO_START0, ATA0_IO_START1}, 
                {ATA0_IO_STOP0, ATA0_IO_STOP1}, 0,
                0, 0, 0, 0, 0
            },
            IDE_LOCAL, ATA0_NUM_DRIVES, ATA0_INT_VEC, 
            ATA0_INT_LVL, ATA0_CONFIG, ATA_SEM_TIMEOUT, 
            ATA_WDG_TIMEOUT, 0, 0
        },
        {
            {
                 5, 0,
                 {ATA1_IO_START0, ATA1_IO_START1}, 
                 {ATA1_IO_STOP0, ATA1_IO_STOP1}, 0,
                 0, 0, 0, 0, 0
            },
            IDE_LOCAL, ATA1_NUM_DRIVES, ATA1_INT_VEC, 
            ATA1_INT_LVL, ATA1_CONFIG, ATA_SEM_TIMEOUT, 
            ATA_WDG_TIMEOUT, 0, 0
        }
    };
.CE
where:
.CS
#define ATA0_NUM_DRIVES 2
#define ATA1_NUM_DRIVES 2
#define ATA0_INT_LVL 0x0e
#define ATA1_INT_LVL 0x0f
.CE
A boot EPROM (type 27020 or 27040) is supported 
with Blunk Microsystems' ROM Card 1.0. 
For information on booting from these devices, 
see the Blunk Microsystems documentation.
The program romcard.s, a loader for code programmed in to the EPROM,
is provided to support 
VxWorks with the ROM Card.
In addition, the following configurations are defined in 
the makefile to generate Motorola S-record format from 
bootrom_uncmp or from vxWorks_boot.st :
.TS
center;
l l.
romcard_bootrom_512.hex	boot	ROM image for 27040 (512 KB)
romcard_bootrom_256.hex	boot	ROM image for 27020 (256 KB)
romcard_vxWorks_st_512.hex	bootable VxWorks image for 27040 (512 KB)
.TE
Neither the ROM Card nor the EPROM is distributed with VxWorks.
For more information visit http://www.blunkmicro.com/

.SS "Boot Methods"
The boot methods are affected by the boot parameters.  If no password is
specified, RSH (remote shell) protocol is used.  If a password is specified,
FTP protocol is used, or, if the flag is set, TFTP protocol is used.

These protocols apply only to Ethernet devices

.SS "ROM Considerations"
Not applicable to this BSP

.SH "SPECIAL CONSIDERATIONS"
.SS "Delivered Objects"
.ne 20
.TS
center;
c c
l l.
Object Name	Description
_
vxWorks	T{
image with no target shell or target symbol table. Network is included
and initialized.
T}
VxWorks.st	T{
fully linked stand alone image including
a target based shell, symbol table, and network 
interface. Note that the network interface is not initialized.
There is no WDB agent.
T}
bootrom_uncmp	T{
bootrom with uncompressed image which will run in lower memory
T}
mkboot.o	vxWorks utility for creating boot disks
.TE

.SS "Make Targets"
The BSP supports the following make targets:

.TS E
expand;
cw(1i) cw(2i) c
lw(1i) lw(2i) l.
Image Name	Description	Comments
=
vxWorks_rom	T{
high memory uncompressed bootable vxWorks
T}
vxWorks_rom_low	T{
low memory uncompressed bootable vxWorks
T}	T{
feiattach may not obtain enough memory
T}
vxWorks.st_rom	T{
high memory compressed bootable vxWorks.st
T}
bootrom	T{
low memory compressed bootrom
T}
bootrom_uncmp	T{
low memory uncompressed bootrom
T}
bootrom_high	T{
high memory compressed bootrom
T}	T{
May fail to boot; psychadelic video suggest video memory
or controller corrupted
T}
vxWorks	standard "Tornado-style" vxworks
vxWorks.st	T{
Fully linked stand alone vxWorks
including target based shell, symbol table, and network 
interface. The network interface is not initialized.
There is no WDB agent.
T}
vxWorks.res_rom	T{
Standalone VxWorks image that can be put in ROM.
Only the data segment of this ROM image is copied into RAM.
T}
vxWorks.res_rom_nosym	T{
Standalone VxWorks image that can be put in ROM.
Only the data segment of this ROM image is copied into RAM.
There is no symbol table. 
T}
_
.TE

.SS "Special Routines"
The following routines are specific to this BSP and are available
to the user. The are written in assembly code in sysALib.s. For 
further details see the man pages:
.TS
expand;
sysInByte() | input one byte from I/O space
sysInWord() | input one word from I/O space
sysInLong() | input one long-word from I/O space
sysOutByte() | output one byte to I/O space
sysOutWord() | output one word to I/O space
sysOutLong() | output one long-word to I/O space
sysInWordString() | input word string from I/O space
sysInLongString() | input long string from I/O space
sysOutWordString() | output word string to I/O space
sysOutLongString() | output long string to I/O space
.TE

.SS "Known Problems"
bootrom_high (high memory compressed bootrom) 
may fail to boot; psychadelic video suggest video memory
or controller corrupted

vxWorks_rom_low (low memory uncompressed bootable vxWorks)
feiattach may fail: feiattach might not be
able to obtain enough memory

Failures during Validation Test Suite (VTS):

NVRAM test: fails as this BSP has no NVRAM.

Catastrophic error test: fails as the VTS expects
an exception message but this BSP displays none;
however, the BSP correctly recovers
by rebooting the target.

Bootline Test :
Bus error test for local error address fails.
Bus error test for off-board error address fails.
Boot commands test failed as the VTS incorrectly presumes a big
endian architecture.

.SS "Other"
The valid auxiliary clock rates are between 2 ticks per 
second and 2 to the power of 13 ticks per second (2^13 = 8192).

Warm booting (reboot) is dependent upon the following parameters (shown with
default values) in config.h:

.CS
#define SYS_WARM_BIOS       0   /* warm start from BIOS */
#define SYS_WARM_FD         1   /* warm start from FD */
#define SYS_WARM_ATA        2   /* warm start from ATA */
#define SYS_WARM_TFFS       3   /* warm start from DiskOnChip */

#define SYS_WARM_TYPE       SYS_WARM_FD /* warm start device */
#define SYS_WARM_FD_DRIVE   0   /* 0 = drive a:, 1 = b: */
#define SYS_WARM_FD_TYPE    0   /* 0 = 3.5" 2HD, 1 = 5.25" 2HD */
#define SYS_WARM_ATA_CTRL   0   /* controller 0 */
#define SYS_WARM_ATA_DRIVE  0   /* 0 = c:, 1 = d: */
.CE

If SCSI configuration fails, it may be the result of improper SCSI bus 
termination. Check termination carefully on all devices, including
the controller. Note that some devices
have built in termination that is configured via a jumper.

In order to dynamically update the MMU table entries,
prior to MMU initialization,
several dummy entries
have been added to the end of the memory description
table sysPhysMemDesc. This allows PCI device configuration space,
configured by the BIOS, to be properly mapped into the VxWorks memory
map. This is done by sysMmuMapAdd() in sysLib.c.

This BSP does not support ISA PnP. Such devices can be supported if
PnP is disabled and the device parameters (IO address, Memory address,
IRQ, DMA channel etc) is set to match its BSP driver configuration. If
the device uses soft-configuration instead of jumpers, an appropriate
utility program, usually available from the device manufacturer,
should be used to setup the device parameters.

.SS "Pentium and PentiumPro support"
Following features are supported for Pentium and PentiumPro, and they
are enabled in sysHwInit().  See pentiumLib for more details of these
features.

.IP "Memory Type Range Registers (MTRRs)" 
If INCLUDE_MTRR_GET is defined, contents of the MTRRS are copied to the 
sysMtrr[] table.  Otherwise it sets the contents of sysMtrr[] to the MTRRs.

.IP "Performance Monitoring Counter (PMC)"
This is an optional feature configured by INCLUDE_PMC macro.

.IP "Machine Check Architecture (MCA)"

.IP "Time Stamp Counter (TSC)"
If INCLUDE_TIMESTAMP_TSC is defined, on-chip TSC is used for the 
time stamp driver.  PENTIUM_TSC_FREQ specifies its frequency.
If it is difined to zero, the frequency is automatically detected.

.IP "Enhanced MMU"
The enhanced MMU is included by defining INCLUDE_MMU_PENTIUMPRO macro.
4KB-page and 4MB-page are supported and configurable by VM_PAGE_SIZE
macro.  Two new memory attribute macros, VM_STATE_WBACK and 
VM_STATE_GLOBAL, are added.  
VM_STATE_WBACK (clear PWT bit) and VM_STATE_WBACK_NOT (set PWT bit)
represents the cache mode of a page.
VM_STATE_GLOBAL (set GLOBAL bit) and VM_STATE_GLOBAL_NOT (clear
GLOBAL bit) represents the global characteristics of a page.

.IP "Advanced Programmable Interrupt Controller (APIC)"
PentiumPro's APIC is supported in either Virtual Wire Mode (define
VIRTUAL_WIRE_MODE in config.h) or Symmetric IO Mode (define 
SYMMETRIC_IO_MODE in config.h).  If neither of them is defined,
VxWorks uses a mode that is set up by BIOS, which could be Virtual
Wire Mode or PIC Mode.  Only Local APIC is used in Virtual Wire Mode,
both Local APIC and IO APIC are used in Symmetric IO Mode.

.IP "Data Cache Mode"
CACHE_COPYBACK data cache mode is default for Pentium. 
It uses Write Back data cache mode with the generic MMU library
for X86 architecture.
CACHE_COPYBACK and CACHE_SNOOP_ENABLE is deafult for PentiumPro.
CACHE_COPYBACK has no effect to the PentiumPro's MMU library
that support page basis Write Back/Write Through cache mode.
CACHE_SNOOP_ENABLE respects MESI cache protocol and doesn't invoke
the WBINVD (write back and invalidate cache) instruction in the
flush routine in the cache library.

.SS "MTRR"
This table shows effective memory type depending on MTRR, PCD, and
PWT setting.

.TS E
expand;
c c c c
c c c c
l l l l.
MTRR mem type	PCD value	PWT value	Effective mem type
_
UC	X	X	UC
WC	0	0	WC
	0	1	WC
	1	0	WC
	1	1	UC
WT	0	X	WT
	1	X	UC
WP	0	0	WP
	0	1	WP
	1	0	UC
	1	1	UC
WB	0	0	WB
	0	1	WT
	1	X	UC
_
.TE

This table shows MTRR memory types and their properties.

.TS E
expand;
c c c c c
c c c c c
l l l l l.
	Cacheable in		Allows	Memory
	L1 and L2	Writeback	Speculative	Ordering
Mnemonic	Caches	Cacheable	Reads	Model
_
UC	No	No	No	Strong Ordering
WC	No	No	Yes	Weak Ordering
WT	Yes	No	Yes	Speculative
				Processor Ordering
WP	Yes for reads,	No	Yes	Speculative
	No for writes			Processor Ordering
WB	Yes	Yes	Yes	Speculative
				Processor Ordering
_
.TE

.SH "AUTHOR"
Original port by Hdei Nunoe of Wind River Systems, Alameda, CA.

.SH SEE ALSO
.tG "Getting Started,"
.pG "Configuration"
.pG "Architecture Appendix"

.SH "BIBLIOGRAPHY"
Refer to the vendor's documentation for the motherboard and
any adaptor cards installed.
