/*
 * -----------------------------------------------------------------
 * IllegalAssignmentError.java :
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */

package javax.realtime;

/**
 * The exception thrown on an attempt to make an illegal assignment.
 * For example, this will be thrown if logic attempts to assign a reference
 * to an object in <tt>ScopedMemory</tt> to a field in an object in 
 * <tt>ImmortalMemory</tt>.
 *
 * @author Pratik Solanki
 */

public class IllegalAssignmentError extends Error 
{
    /**
     * A constructor for <tt>IllegalAssignmentError</tt>.
     */
    public IllegalAssignmentError() 
    {
        super();
    }

    /**
     * A descriptive constructor for <tt>IllegalAssignmentError</tt>.
     * @param description  Description of the error.
     */
    public IllegalAssignmentError(String description) 
    {
        super(description);
    }
}
