/*
 * -----------------------------------------------------------------
 * InaccessibleAreaException.java : Thrown when you try to access a
 * memory are that is not on your stack.
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */

package javax.realtime;

/**
 * The specified memory area is not above the current allocation 
 * context on the current thread scope stack.
 */
public class InaccessibleAreaException extends Exception
{

    /**
     * A constructor for <code>InaccessibleAreaException</code>.
     */
    public InaccessibleAreaException()
    {
        super();
    }

    /**
     * A descriptive constructor for <code>InaccessibleAreaException</code>.
     *
     * @param description Description of the error.
     */
    public InaccessibleAreaException(String description)
    {
        super(description);
    }
}
