/*
 * -----------------------------------------------------------------
 * PriorityInheritance.java :
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */

package javax.realtime;

/**
  Monitor control class specifying use of the priority inheritance
  protocol for object monitors.  Objects under the influence of this
  protocol have the effect that a thread entering the monitor will boost
  the effective priority of the thread in the monitor to its own effective
  priority.  When that thread exits the monitor, its effective priority
  will be restored to its previous value.

  See also {@link MonitorControl} and {@link PriorityCeilingEmulation}
  
  */

public class PriorityInheritance extends MonitorControl {
    static PriorityInheritance singleton = null;
  
  /**
    Return a pointer to the singleton <code>PriorityInheritance</code>.
    */
    public static PriorityInheritance instance()
    {
	if (singleton == null)
	    singleton = new PriorityInheritance();

	return singleton;
    }
}
