/*
 * -----------------------------------------------------------------
 * ThrowBoundaryError.java : 
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */

package javax.realtime;


/**
 * The error thrown by <code> public void enter(Runnable logic)</code>
 * when a <code>java.lang.Throwable</code> allocated from memory that 
 * is not usable in the surrounding scope tries to propagate out of the
 * scope of the <code> public void enter(Runnable logic)</code>.
 *
 * @author Pratik Solanki
 */
public class ThrowBoundaryError extends java.lang.Error
{
    /**
     * A constructor for <code>ThrowBoundaryError</code>. 
     */
	public ThrowBoundaryError()
	{
		super();
	}

    /**
     * A descriptive constructor for <code>ThrowBoundaryError</code>. 
     *
     * @param description Description of the error.
     */
	public ThrowBoundaryError(String description)
	{
		super(description);
	}
}
