/*
 * -----------------------------------------------------------------
 * UnsupportedPhysicalMemoryException.java :
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */

package javax.realtime;

/**
 * Thrown when the underlying hardware does not support the type of 
 * physical memory given to the physical memory <code> create()</code>
 * method.
 *
 * @see RawMemoryAccess
 * @see RawMemoryFloatAccess
 * @see ImmortalPhysicalMemory
 * @see LTPhysicalMemory
 * @see VTPhysicalMemory
 * @author Pratik Solanki
 */
public class UnsupportedPhysicalMemoryException extends Exception
{
    /**
     * A constructor for <code>UnsupportedPhysicalMemoryException</code>.
     */
    public UnsupportedPhysicalMemoryException()
    {
    }

    /**
     * A descriptive constructor for 
     * <code>UnsupportedPhysicalMemoryException</code>.
     *
     * @param description The description of the exception.
     */
    public UnsupportedPhysicalMemoryException(String description)
    {
    	super(description);
    }
}
