/*
 * @(#)linker_md.c	1.4 00/11/09
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifdef CVM_DYNAMIC_LINKING

#include "javavm/include/porting/linker.h"
#include "javavm/include/porting/ansi/stdio.h"
#include "javavm/include/porting/ansi/string.h"
#include <dlfcn.h>

void *
CVMdynlinkOpen(const void *absolutePathName)
{
    return dlopen((const char *) absolutePathName, RTLD_LAZY);
}

void *
CVMdynlinkSym(void *dsoHandle, const void *name)
{
    /* Note: a NULL handle means builtin library */
    if (dsoHandle == NULL) {
	return dlsym(RTLD_DEFAULT, (const char *) name);
    } else {
	return dlsym(dsoHandle, (const char *) name);
    }
}

void
CVMdynlinkClose(void *dsoHandle)
{
    dlclose(dsoHandle);
}

/* Basically copied from the JDK */
CVMBool
CVMdynlinkBuildLibName(void *holder, int holderlen,
		       void *pname, void *fname)
{
    const int pnamelen = pname ? strlen(pname) : 0;
    char *suffix;

#ifdef CVM_DEBUG
    suffix = "_g";
#else
    suffix = "";
#endif 

    /* Truncate on buffer overflow and return an error. */
    if (pnamelen + strlen(fname) + 10 > (size_t) holderlen) {
        *((char *) holder) = '\0';
        return CVM_FALSE;
    }

    if (pnamelen == 0) {
        sprintf((char *) holder, "lib%s%s.so",
		    (char *) fname, (char *) suffix);
    } else {
        sprintf((char *) holder, "%s/lib%s%s.so",
		    (char *) pname, (char *) fname, (char *) suffix);
    }
    return CVM_TRUE;
}

#endif /* #defined CVM_DYNAMIC_LINKING */
