import java.io.*;
import java.net.*;

public class ServerThread extends Thread
{
	Pipe p_write;
	InetAddress host;
	DatagramSocket cli;
	DatagramPacket pkt;
	byte[] buf = new byte[16];
	long prev,curr;
	int diff,noheap;

	public ServerThread(String server,int port,int noheap)
	{
		try {
			this.noheap = noheap;
			host = InetAddress.getByName(server);
			cli = new DatagramSocket(port,host);
			p_write = Pipe.getInstance();
		}catch(Exception e) {
			System.err.println("err in connect / data.getBytes()");
		}
		System.out.println("Construction done "+port+" type "+noheap);
	}

	public void run()	
	{
		prev = System.currentTimeMillis();
		while(true) {
			try {
				pkt = new DatagramPacket(buf,0,buf.length);
				//curr = System.currentTimeMillis();
				//diff = (int)(curr - prev);
				//prev = curr;
				cli.receive(pkt);
				String netstr = new String(pkt.getData(),0,pkt.getLength());
				diff = new Integer(netstr).intValue();
				System.out.println(""+diff);
				if(noheap == 1)
					p_write.noheappipe_write(diff);
				else if(noheap == 0)
					p_write.pipe_write(diff);
			}catch(Exception e) {
				System.err.println("err in receiving data "+e);
				System.exit(0);
			}
		}
	}
}
