import javax.realtime.*;
import com.timesys.*;

/* 
   How to run this test:
   Copy this file into build/linux/bin and compile with

   then run. You will see the dispatcher pid appear, probably amongst a
   bunch of other debugging output as per the print statement near the
   bottom of this file. Send that process id a the signal indicated by
   event.bindTo method call. I use event.bindTo("63") and kill -63 <pid>
   from another terminal. When you are done send the <pid> signal 9 to 
   kill the app.
*/

public class AsyncEventTest
{
  public static void main(String[] argv)
  {
    RealtimeThread rtt =
      new RealtimeThread(null, null, null, ImmortalMemory.instance(),
			       null, null){
	  public void run()
	  {
	    System.out.print("nhrt running\n");
	    
	    RealtimeThread rt2 = new RealtimeThread();
	    

	    System.out.print("creating AsyncEvent\n");
	    AsyncEvent event = new AsyncEvent();

	    System.out.print("creating handler\n");
	    AsyncEventHandler h =
	      new AsyncEventHandler(null,null,null,
					 new LTMemory(1048576,1048576),
					 null, true){
		  public void handleAsyncEvent(){
		    System.out.print("handler running\n");
		    //for(int i=0; i<10000000;i++);
		    //System.out.print("handler done\n");
		  }
		};
	    
	    event.addHandler(h);
	    for(int i=32; i<64; i++){
		event.bindTo(Integer.toString(i));
	    }


	    try{
	      System.out.print("Dispatcher pid: "+Dispatcher.getPID()+"\n");
	    }
	    catch(Exception e){}
	    System.out.print("run counting\n");
	    for(int i=0;i<100000000;i++);
	    System.out.print("run exiting\n");
	  }
	};
    
    rtt.start();
    
    System.out.print("main now exiting\n");
  }
}
