import javax.realtime.*;

public class IllegalAssignmentTest extends NoHeapRealtimeThread
{
    static final int memsize = 1024*1024;
    
    public IllegalAssignmentTest(MemoryArea m)
    {
        super(null, null, null, m, null, null);
    }
    
    public static void main(String[] args)
    {
        ScopedMemory s = new LTMemory(memsize, memsize);
        IllegalAssignmentTest i = new IllegalAssignmentTest(s);
        i.start();
        try
        {
        Thread.sleep(10000);
        }
        catch(Exception e) { e.printStackTrace(); }
    }

    public void run()
    {
       //try
       //{
        System.out.println("Starting tests");
        /* Test 1 - Immortal holding a reference to scoped */
        //Temp t = (Temp) ImmortalMemory.instance().newInstance(Class.forName("Temp"));
        //t.ref = new Temp();

        /* Test 2 - Heap holding a reference to scoped */
        //Temp t = (Temp) HeapMemory.instance().newInstance(Class.forName("Temp"));
        //t.ref = new Temp();

        /* Test 3 - outer scope holding a reference to Inner scope */
        Temp t1 = new Temp();
        System.out.println("Created new object");
        MyRunnable2 r = new MyRunnable2(new Temp[2]); //(t1);
        System.out.println("Created new runnable"); 
        ScopedMemory sm2 = new VTMemory(1024*8, 1024*8);
        sm2.enter(r);

        Temp[] t3 = r.t;
        //Temp t3 = r.t;
        System.out.println("Finished tests");
      /* }
      catch(ClassNotFoundException e)
       {
         e.printStackTrace();
       }
       catch(IllegalAccessException i)
       {
         i.printStackTrace();
       }
       catch(InstantiationException ie)
       {
         ie.printStackTrace();
       }*/
    }
}

class MyRunnable2 implements Runnable
{
    public Temp[] t;
    
    public MyRunnable2(Temp[] t1)
    {
        t = t1;
    }
    
    public void run()
    {
        System.out.println("Starting the inner run method"); 
        //t.ref = new Temp();
        //Temp t2 = new Temp();
        //t2.ref = t;

        t[0] = new Temp();
        //System.out.println("Memory area for array = " + MemoryArea.getMemoryArea(new Temp[2]));
        System.out.println("Finished the inner run method");
        //t = t2;
    }
}
