import javax.realtime.*;

public class ConstructorSM extends RealtimeThread
{
    public ConstructorSM()
    {
        super(null, null, null, ImmortalMemory.instance(), null, null);
    }
    
    public static void main(String[] args)
    {
        test();
    }
    
    public static void test()
    {
        try
        {
        ConstructorSM c = (ConstructorSM) ImmortalMemory.instance().newInstance(ConstructorSM.class);
        c.start();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public void run()
    {
        System.out.println("Initial stack");
        MemStack.printStack();
        ScopedMemory sm1 = new LTMemory(1024*24, 1024*24);
        sm1.enter(new Runnable() 
            {
                public void run()
                {
                    System.out.println("Printing stack after entering sm1");
                    MemStack.printStack();
                    ScopedMemory sm2 = new VTMemory(24*1024, 24*1024);
                    sm2.enter(new Runnable()
                    {
                        public void run()
                        {
                            System.out.println("Printing stack after entering sm2");
                            MemStack.printStack();
                            ScopedMemory sm3 = new LTMemory(24*1024, 24*1024);
                            sm3.enter(new Runnable()
                            {
                                public void run()
                                {
                                try
                                {
                                System.out.println("Printing stack after entering sm3"); 
                                MemStack.printStack();
                                System.out.println("Now trying to construct an object in sm1 which will enter a new memory area");
                                MemoryArea mem = RealtimeThread.getOuterMemoryArea(1);
                                System.out.println("Got outer memory area " + mem); 
                                WonderfulConstructor wc = (WonderfulConstructor)mem.newInstance(WonderfulConstructor.class);
                                System.out.println("Back from constructing. Printing stack again");
                                MemStack.printStack();
                                }
                                catch(Exception e)
                                {
                                    e.printStackTrace();
                                }
                                }
                            });
                        }
                                 
                    });
                }
            });
    }
}
