import javax.realtime.*;

public class CyclicStackTest extends RealtimeThread
{
    static int memsize = 1024*16;
    public CyclicStackTest()
    {
        super();
    }
    
    public static void main(String[] args)
    {
        System.out.println("\nThis test tries to enter a scope thats already on\n" +
                            "the stack and hence should fail with a ScopedCycleException\n"); 
        CyclicStackTest cst = new CyclicStackTest();
        cst.start();
    }

    public void run()
    {
        System.out.println("String test");
        ScopedMemory s1 = new LTMemory(memsize, memsize);
        s1.enter( new Runnable() {
                public void run()
                {
                    ScopedMemory s2 = new LTMemory(memsize, memsize);
                    s2.enter(new Runnable() {
                        public void run()
                        {
                            ScopedMemory s3 = new LTMemory(memsize, memsize);
                            s3.enter(new Runnable() {
                                public void run()
                                {
                                    System.out.println("Stack after entering 3 memory areas");
                                    MemStack.printStack();
                                    System.out.println("Now I'll try to enter s1 again");
                                    MemoryArea mem = RealtimeThread.getOuterMemoryArea(1);
                                    mem.enter(new Runnable(){
                                            public void run()
                                            {
                                                System.out.println("This should NEVER be printed!!!!");
                                            }
                                        });
                                }
                            });
                        }
                    });
                }
        });
        System.out.println("Test finished!");
    }
}
