import javax.realtime.*;

public class UTScopedMemory
{
	public static void main(String[] args)
	{
		UTScopedMemory u = new UTScopedMemory();
		u.runTest();
		
		System.gc();
		System.runFinalization();
		System.out.println("Finished everything");
		System.exit(0);
	}

	public void runTest()
	{
		try
		{
				ScopedMemory immortal = new LTMemory(1024*1024, 1024*1024);
				for(int i=0; i<10; i++)
				{
					ImmortalObject obj1 = new ImmortalObject();
					ImmortalObject obj2 = (ImmortalObject) immortal.newInstance(obj1.getClass());
					System.out.println("heap object: " + obj1 + " and it is allocated in " + MemoryArea.getMemoryArea(obj1));
					System.out.println("immortal object: " + obj2 + " and it is allocated in " + MemoryArea.getMemoryArea(obj2));
				}
				System.out.println("Finished creation");
						
				System.out.println("Immortal mem left = " + immortal.memoryRemaining());
				System.out.println("Immortal mem consumed = " + immortal.memoryConsumed());
		

		}
		catch(Throwable e)
		{
            System.out.println("Caught Exception");
//			e.printStackTrace(); 
		}
	}
	
	protected void finalize()
	{
		System.out.println("Reached finalize in UTImmortalMemory");
	}
}

