//package javax.realtime.calltests;

/*
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 2000  All Rights Reserved
 */


/* 			ImmortalPhysicalMemoryTest

Subtest 1:
	"public static ImmortalPhysicalMemory create(java.lang.Object type, 
	long size"

Subtest 2:
	"public static ImmortalPhysicalMemory create(java.lang.Object type, 
	long base, long size);

Subtest 3:
	"public static void setFactory(PhysicalMemoryFactory factory)"
*/

import javax.realtime.*;

public class ImmortalPhysicalMemoryTest 
{
    public static void run() 
    {
	ImportanceParameters ip = null;
	Object o = null;

	// constructors are protected

	Tests.newTest("ImmortalPhysicalMemoryTest");
	Tests.increment();

	/* Subtest 1:
	** Method "public static ImmortalPhysicalMemory create(
	** java.lang.Object type, long size"
	*/
	try {
	    System.out.println("ImmortalPhysicalMemory: create(Object, long)");
	    o = ImmortalPhysicalMemory.create(new Object(), 1024L);
	    if( !(o instanceof ImmortalPhysicalMemory) )
		throw new Exception("Return Object is not instance of "+
				    "ImmortalPhysicalMemory");
	} catch (Exception e) {
	    System.out.println("ImmortalPhysicalMemory: create(Object, long) "+
			       "failed");
	    Tests.fail("ImmortalPhysicalMemory.create(new Object(), 1024L)",e);
	}
	
	/* Subtest 2:
	**  Method "public static ImmortalPhysicalMemory create(
	** java.lang.Object type, long base, long size);
	*/
	Tests.increment();
	try {
	    System.out.println("ImmortalPhysicalMemory: create(Object,long,"+
			       "long)");
	    o = ImmortalPhysicalMemory.create(new Object(), 4096L, 1024L);
	    if( !(o instanceof ImmortalPhysicalMemory) )
		throw new Exception("Return object is not instanceof "+
				    "ImmortalPhysicalMemory"); 
	} catch (Exception e) {
	    System.out.println("ImmortalPhysicalMemory: create(Object,long,"+
			       "long) failed");
	    Tests.fail("ImmortalPhysicalMemory.create(new Object(), 1024L, "+
		       "1024L)",e);
	}

	/* Subtest 3:
	** Method "public static void setFactory(PhysicalMemoryFactory 
	** factory)"
	*/
	Tests.increment();
	try {
	    System.out.println("ImmortalPhysicalMemory: setFactory(Physical"+
			       "MemoryFactory)");
	    PhysicalMemoryFactory factory = null;
	    ImmortalPhysicalMemory.setFactory(factory);
			
	} catch (Exception e) {
	    System.out.println("ImmortalPhysicalMemory: setFactory(Physical"+
			       "MemoryFactory) failed");
	    Tests.fail("ImmortalPhysicalMemory.setFactory(factory)",e);
	}

	Tests.printSubTestReportTotals("ImmortalPhysicalMemoryTest");
    }
}
