/* InterruptibleTimedThread - This class is a subclass of RealtimeThread 
**                            used in
**		              subtest 4 of TimedTest to provide a thread
**			      containing interruptible logic. A shared
**			      semaphore is passed into the constructor and then
**			      into the interruptible logic constructor so that
**			      the master test can wait for and be notified by 
**			      the interruptible logic.  
*/
import javax.realtime.*;

public class InterruptibleTimedThread extends RealtimeThread 
{
    Timed timed;
    Semaphore semaphore;

    public InterruptibleTimedThread(Timed shared_timed,Semaphore 
				    shared_semaphore)
    {
	super();
	System.out.println("InterruptibleTimedThread: InterruptibleTimed"+
			   "Thread(Timed,Semaphore)");
	timed = shared_timed;
	semaphore = shared_semaphore;

    }

    public void run() {

	System.out.println("InterruptibleTimedThread: run()");

	try {
	    MyInterruptibleTimed mi = new MyInterruptibleTimed(semaphore);
	    boolean x = timed.doInterruptible(mi);
	} catch(Exception e) {
	    System.out.println("InterruptibleTimedThread: timed.do"+
			       "Interruptible(mi) in Subtest 4 of the "+
			       "TimedTest threw an exception");
	    Tests.threadFail();
	    e.printStackTrace();
	}

    }
}
