/* NewScheduler - is a subclass of Scheduler used to test the non-abstract
**		  method, changeIfFeasible() of the Scheduler class in 
**	          SchedulerTest.  
**		  The PriorityScheduler (an RTSJ provided subclass of 
**                Scheduler)
**		  currently overrides this method.
*/
import javax.realtime.*;
import java.lang.reflect.*;
import java.util.*;
	

public class NewScheduler extends Scheduler {
    public final int MAX_PRIORITY = 265;
    public final int MIN_PRIORITY = 10;
		
    static HashSet feasibilitySet = null;
    public boolean isFeasible()
    {
	System.out.println("NewScheduler: isFeasible()");
	return true;
    }
    public String getPolicyName() {
	System.out.println("NewScheduler: getPolicyName()");
	return new String("Fixed Priority");
    }
    public void removeFromFeasibility(Schedulable schedulable) {
	System.out.println("NewScheduler: removeFromFeasibility(Schedulable)");
	if (feasibilitySet != null)
	    feasibilitySet.remove(schedulable);
    }
    public void addToFeasibility(Schedulable schedulable) {
	System.out.println("NewScheduler: addToFeasibility(Schedulable)");
	RealtimeThread t = null;
	PriorityParameters p = null;
	synchronized (this)
	    {
		if (feasibilitySet == null)
		    {
			feasibilitySet = new HashSet();
		    }
	    }
	
	if (!feasibilitySet.contains(schedulable))
	    {
		try
		    {
			t = (RealtimeThread) schedulable;
			p = (PriorityParameters) t.getSchedulingParameters();
		    }
		catch(Exception e)
		    {
		    }
		if (p.getPriority() >=MIN_PRIORITY)
		    t.setRTPriority(p.getPriority() - MIN_PRIORITY );
		feasibilitySet.add(schedulable);
	    }
    }

    public void fireSchedulable(Schedulable schedulable) 
    {
	System.out.println("NewScheduler: fireSchedulable(Schedulable)");
	return;
    }

}

