//package javax.realtime.calltests;

/*
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 2000  All Rights Reserved
 */


/* 				PhysicalMemoryFactorTest

NOTE:  Because the methods of PhysicalMemoryFactory are protected and I cannot
       create a subclass of DefaultPhysicalMemoryFactory because it's 
       constructor is private, there are no subtests for the methods

Subtest 1:
	"public static final java.lang.String ALIGNED"

Subtest 2:
	"public static final java.lang.String BYTESWAP"

Subtest 3:
	"public static final java.lang.String DMA"

Subtest 4:
	"public static final java.lang.String SHARED"
*/


import javax.realtime.*;

public class PhysicalMemoryFactoryTest 
{

    public static void run() 
    {
	Object o;
	Tests.newTest("PhysicalMemoryFactoryTest");

	/* Subtest 1:
	** Field "public static final java.lang.String ALIGNED"
	*/
	Tests.increment();
	try {
	    System.out.println("PhysicalMemoryFactoryTest: ALIGNED");
	    o = PhysicalMemoryFactory.ALIGNED;
	    if( !(o instanceof String) )
		throw new Exception("ALIGNED is not instanceof String");
	} catch (Exception e) {
	    System.out.println("PhysicalMemoryFactoryTest: ALIGNED failed");
	    Tests.fail("PhysicalMemoryFactory.ALIGNED",e);
	}

	/* Subtest 2:
	** Field "public static final java.lang.String BYTESWAP"
	*/
	Tests.increment();
	try {
	    System.out.println("PhysicalMemoryFactoryTest: BYTESWAP");
	    o = PhysicalMemoryFactory.BYTESWAP;
	    if( !(o instanceof String) )
		throw new Exception("BYTESWAP is not instanceof String");
	} catch (Exception e) {
	    System.out.println("PhysicalMemoryFactoryTest: BYTESWAP failed");
	    Tests.fail("PhysicalMemoryFactory.BYTESWAP",e);
	}

	/* Subtest 3:
	** Field "public static final java.lang.String DMA"
	*/
	Tests.increment();
	try {
	    System.out.println("PhysicalMemoryFactoryTest: DMA");
	    o = PhysicalMemoryFactory.DMA;
	    if( !(o instanceof String) )
		throw new Exception("DMA is not instanceof String");
	} catch (Exception e) {
	    System.out.println("PhysicalMemoryFactoryTest: DMA failed");
	    Tests.fail("PhysicalMemoryFactory.DMA",e);
	}

	/* Subtest 4:
	** Field "public static final java.lang.String SHARED"
	*/
	Tests.increment();
	try {
	    System.out.println("PhysicalMemoryFactoryTest: SHARED");
	    o = PhysicalMemoryFactory.SHARED;
	    if( !(o instanceof String) )
		throw new Exception("SHARED is not instanceof String");
	} catch (Exception e) {
	    System.out.println("PhysicalMemoryFactoryTest: SHARED failed");
	    Tests.fail("PhysicalMemoryFactory.SHARED",e);
	}
	
	Tests.printSubTestReportTotals("PhysicalMemoryFactoryTest");	
    }
}
