//package javax.realtime.calltests;

/*
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 2000  All Rights Reserved
 */


/*				ScopedPhysicalMemoryTest

Subtest 1
	"public static ScopedPhysicalMemory create(java.lang.Object type, long
	base, long size)"

Subtest 2
	"public static void setFactory(PhysicalMemoryFactory factory)"
*/

import javax.realtime.*;

public class ScopedPhysicalMemoryTest 
{

    public static void run() 
    {
	ScopedPhysicalMemory spm = null;
	Object o = null;

	// constructors are protected
	Tests.newTest("ScopedPhysicalMemoryTest");

	/* Subtest 1
	** Method "public static ScopedPhysicalMemory create(java.lang.Object
	** type, long base, long size)"
	*/
	Tests.increment();
	try {
	    System.out.println("ScopedPhysicalMemoryTest: create(Object,long,"+
			       "long)");
	    long base = 4096;
	    long size = 1000;
	    o = ScopedPhysicalMemory.create(new Object(), base, size);
	    if( !(o instanceof ScopedPhysicalMemory && o instanceof 
		  ScopedMemory) )
		throw new Exception("Return object is not instanceof "+
				    "ScopedPhysicalMemory nor ScopedMemory");
	} catch (Exception e) {
	    System.out.println("ScopedPhysicalMemoryTest: create(Object,long,"+
			       "long) failed");
	    Tests.fail("ScopedPhysicalMemory.create()",e);
	}

	/* Subtest 2
	** Method "public static void setFactory(PhysicalMemoryFactory 
	** factory)"
	*/
	Tests.increment();
	try {
	    System.out.println("ScopedPhysicalMemoryTest: setFactory(Physical"+
			       "MemoryFactory)");
	    PhysicalMemoryFactory factory = null;
	    ScopedPhysicalMemory.setFactory(factory);
	} catch (Exception e) {
	    System.out.println("ScopedPhysicalMemoryTest: setFactory(Physical"+
			       "MemoryFactory) failed");
	    Tests.fail("ScopedPhysicalMemory.setFactory()",e);
	}
		
	Tests.printSubTestReportTotals("ScopedPhysicalMemoryTest");
    }
}
