import javax.realtime.*;
import java.util.*;

class MyRealtimeThread extends RealtimeThread {

    final int CHANCE_GET_OBJECT=15;
    final int CHANCE_RELEASE_OBJECT=10;
    final int CHANCE_MEMORY_ENTER=10;

    final int CHANCE_QUIT=10;

    int num_objects, quit, entering;

    Random r;

    MyObject objs[];

    sanity_checker san_chk;
    ObjectFactory of;
    MemoryFactory mf;

    public MyRealtimeThread() {
	objs=new MyObject[CHANCE_GET_OBJECT];
	num_objects=0;
	r=new Random();
	quit=0;
	entering=0;
    }

    public void set_sanity_checker(sanity_checker san) { san_chk=san; }
    public void setObjectFactory(ObjectFactory ob_f) { of=ob_f; }
    public void setMemoryFactory(MemoryFactory mem_f) { mf=mem_f; }

    int getRand() {
	int num=r.nextInt()%100;
	if(num < 0) num*=-1;
	return num;
    }

    public void run() {

	while(quit!=1) {

	    System.out.println("Pt0");

	    if(entering != 1) san_chk.lock(this);
	    entering=0;

	    if(getRand() < CHANCE_QUIT) quit=1;

	    System.out.println("Pt1");
	    
	    if(getRand()+num_objects < CHANCE_GET_OBJECT) {

		System.out.println("Pt1.5");
		
                //This code will get an object reference to hold onto
		// and also let san_chk know that this thread and the 
		// returned object are now attached for the purpose of later
		// sanity checking (in san_chk)
		int id=of.getObjectData().getId();
		MemoryArea ma=of.getObjectData().getMemData().getMemArea();

		if(ma instanceof MyHeapMemory) {
		    objs[num_objects] = ((MyHeapMemory)ma).getObject(id);
		} if(ma instanceof MyImmortalMemory) {
		    objs[num_objects] = ((MyImmortalMemory)ma).getObject(id);
		} if(ma instanceof MyLTMemory) {
		    objs[num_objects] = ((MyLTMemory)ma).getObject(id);
		} if(ma instanceof MyVTMemory) {
		    objs[num_objects] = ((MyVTMemory)ma).getObject(id);
		} 
		
		num_objects++;
		san_chk.attach(this, id);

	    }

System.out.println("Pt2");

	    if((getRand() < CHANCE_RELEASE_OBJECT) && (num_objects > 0)) {

System.out.println("Pt2.5");


		int rem=getRand()%num_objects;
		san_chk.detach(this, objs[rem].getId());
		num_objects--;
		for(int x=rem; x<num_objects; x++) {
		    objs[x]=objs[x+1];
		}
	    }

	    System.out.println("Pt3");

	    // FIXME the memory entering thing isn't really worked out too
	    // good yet, so this section of code needs to be looked at in 
	    // more depth later
	    if(getRand() < CHANCE_MEMORY_ENTER) {

		entering=1;

		System.out.println("Pt4");

		MemData md = mf.getMemData();

		san_chk.pushThreadData(this);
		md.getMemArea().enter(this);
		checkReturn(san_chk.popThreadData(this));
		// FIXME
		// This will require some locking stuff, also error cases
		// and a "memory stack" of some sort where, when this all
		// returns, we can make sure that this stuff is aok - have 
		// a scope that allocates from a mem. area, calls enter(), 
		// exits from that mem. area, and upon returning to the
		// original mem. scope will use the object in some way. -
		// push the object data and make sure that it is the same 
		// upon return - basically, after a call to enter the thread
		// is going to need a way to check all of it's data for sanity
	    } 
	    System.out.println("Pt5");

	    if(quit!=1) san_chk.unlock(this);

	    System.out.println("Pt6");

	}

	san_chk.removeThread(this);
	san_chk.unlock(this);

    }

    // This is to make sure that all of the same information is present when
    // a thread exits the runnable method that is passed into a mem area
    public void checkReturn(ThreadData td) {}

    public void setQuit() { quit=1; }

}
