import javax.realtime.*;
import java.io.*;

public class pitest extends RealtimeThread
{

    final int CS = 50;
    final int T1 = 1000;
    final int C1 = 20;
    final int T2 = 2000;
    final int C2 = 100;
    final int T3 = 3995;
    final int C3 = 20;
    Integer lock;
    long commonStart;

    public class RTThread extends RealtimeThread
    {
	final int traceSize = 5000;
	int traceidx = 0;
	
	public class bufrec
	{
	    public long millis;
	    public int stage;
	}

	bufrec [] tracebuf;
	int periodMillis;
	int costMillis;

	RTThread(PriorityParameters p, ReleaseParameters r, int period, int cost)
	{
	    super(p,r);
	    periodMillis = period;
	    costMillis = cost;
	    tracebuf = new bufrec[traceSize];
	    for (int i = 0; i<traceSize; i++)
		{
		    tracebuf[i] = new bufrec();
		}
	}

	void addTimeStamp(long millis, int stage)
	{
	    if (traceidx < traceSize)
		{
		tracebuf[traceidx].millis = millis;
		tracebuf[traceidx].stage = stage;
		traceidx++;
		}
	}

	public void run()
	{
	    int i,j,k;
	    long startMillis;

	    for (i=0;i<30; i++)
		{
		    startMillis = System.currentTimeMillis();
		    // Period processing
		    if (getName().equals("one") || getName().equals("three"))
			{
			    synchronized(lock)
				{
				    //while ((System.currentTimeMillis() - startMillis) < CS)
				    for (k=0; k< CS; k++)
					{
					    addTimeStamp(System.currentTimeMillis() - commonStart,2);

					    // This loop is calibrated for one millisecond
					    for (j=0; j< 5000; j++)
						;
					}
				}
			}
		    //while ((System.currentTimeMillis() - startMillis) < costMillis)
		    for (k=0; k < costMillis; k++)
			{
			    addTimeStamp(System.currentTimeMillis() - commonStart,1);

			    // this loop is calibrated for one millisecond
			    for (j=0; j< 5000; j++)
				;
			}
		    waitForNextPeriod();
		}
	    try
		{
		    // Save data to disk
		    PrintWriter p = new PrintWriter(new FileOutputStream(getName(),true));
		    for (i=0; i< traceSize;i++)
			{
			    p.println(tracebuf[i].millis+" "+tracebuf[i].stage);
			}
		    p.close();
		}
	    catch (Exception e)
		{
		    e.printStackTrace();
		}
	}
    }

    public pitest(SchedulingParameters p)
    {
	super(p);
    }

    public static void main(String args[])
    {
	PriorityParameters p = new PriorityParameters(20);
	pitest t = new pitest(p);
	t.setScheduler(PriorityScheduler.instance());
	t.addToFeasibility();
	t.start();
    }

    public void run()
    {
	PriorityParameters p1 = new PriorityParameters(16);
	PriorityParameters p2 = new PriorityParameters(15);
	PriorityParameters p3 = new PriorityParameters(14);

	commonStart = System.currentTimeMillis()+5000;
	
	AbsoluteTime start = new AbsoluteTime(commonStart,0);
	RelativeTime period1 = new RelativeTime(T1,0);
	RelativeTime period2 = new RelativeTime(T2,0);
	RelativeTime period3 = new RelativeTime(T3,0);
	RelativeTime cost1   = new RelativeTime(C1,0);
	RelativeTime deadline1 = new RelativeTime(T1,0);
	RelativeTime cost2   = new RelativeTime(C2,0);
	RelativeTime deadline2 = new RelativeTime(T2,0);
	RelativeTime cost3   = new RelativeTime(C3,0);
	RelativeTime deadline3 = new RelativeTime(T3,0);
		
	PeriodicParameters sp1 = new PeriodicParameters(start, period1, cost1, deadline1, null, null);
	PeriodicParameters sp2 = new PeriodicParameters(start, period2, cost2, deadline2, null, null);
	PeriodicParameters sp3 = new PeriodicParameters(start, period3, cost3, deadline3, null, null);


	RTThread t1 = new RTThread(p1, (ReleaseParameters) sp1, T1, C1);
	RTThread t2 = new RTThread(p2, (ReleaseParameters) sp2, T2, C2);
	RTThread t3 = new RTThread(p3, (ReleaseParameters) sp3, T3, C3);

	t1.setScheduler(PriorityScheduler.instance());
	t2.setScheduler(PriorityScheduler.instance());
	t3.setScheduler(PriorityScheduler.instance());

	t1.addToFeasibility();
	t2.addToFeasibility();
	t3.addToFeasibility();

	//MonitorControl.setMonitorControl(new PriorityInheritance());

	lock= new Integer(0);

	MonitorControl.setMonitorControl(lock,new PriorityInheritance());
	t3.setName("three");
	t1.setName("one");
	t2.setName("two");

	t1.start();
	t2.start();
	t3.start();
    }

}
