import java.io.*;
import java.lang.*;
import javax.realtime.*;
import com.timesys.*;
import MyThread;

public class sync_tester extends RealtimeThread {

    // To set the length of each period
    final int MULT=5;

    int quit;

    public static mutex mutexes[];
    PipedInputStream watcherin, threadin;
    PipedOutputStream threadout, watcherout;

    seperate sep;

    static MyThread mt[];

    sync_tester() {quit=0;}

    public void killAll() {

	System.out.println("ERROR : there was something bad that occured so "+
			   "all threads will be killed now");

	sep.setquit();

	for(int x=0; x<MyThread.NUM_THREADS; x++) {
	    mt[x].setquit();
	}

	quit=1;

    }

    public int check_running_and_set() {
	for(int x=0; x<MyThread.NUM_THREADS; x++) {

	    if((mt[x].state==MyThread.RUNNING) ||
	       (mt[x].state==MyThread.RUNNABLE)) return 1;

	}
	
	System.out.println("===ALL THREADS FINISHED===");
	
	mt[0].dump_threads();
	mt[0].dump_mutexes();
	
	for(int x=0; x<MyThread.NUM_THREADS; x++) {
	    if(mt[x].state == MyThread.WAITING) {
		System.out.println("Setting state of "+x+
				   " to RUNNABLE");
		mt[x].state=MyThread.RUNNABLE;
	    }
	    if(mt[x].state==MyThread.BLOCKING) mt[x].blockingInc();
	}

	return 0;

    } 

    public int b_read() {

	int a=0;

	try {
	    a = watcherin.read();
	} catch (Exception e) {
	    System.out.println("==="+e);
	    killAll();
	}

	return a;

    }

    public void run() {

	PriorityScheduler p= PriorityScheduler.instance(); 

	try {
	    Scheduler.setDefaultScheduler(p);
	} catch (Exception e) {
	    System.out.println("ERROR SETTING DEFAULT SCHED : "+e);
	}

        AbsoluteTime start = new AbsoluteTime(System.currentTimeMillis() + 
					      5000,0);

	System.out.println("Start time : "+start.toString());
	PeriodicParameters pp=new PeriodicParameters(start, 
				     new RelativeTime(990*MULT,0), 
				     new RelativeTime(50*MULT,0), 
				     new RelativeTime(990*MULT,0),
				     null,null);

	//	System.out.println("This is the sync_tester priority "
	//			   + this.getRTPriority());
	
	System.out.println("sync_tester : Beginning the test");
	
	threadout = new PipedOutputStream();
	
	try {
	    watcherin = new PipedInputStream(threadout);
	} catch(Exception e) {
	    System.out.println("PipedInputStream create failed : "+e);
	}
	
	watcherout = new PipedOutputStream();
	
	try {
	    threadin = new PipedInputStream(watcherout);
	} catch(Exception e) {
	    System.out.println("=== PipedInputStream "+e);
	}
	
	System.out.println("=== Threadin "+threadin);
	System.out.println("=== Threadout "+threadout);
	System.out.println("=== Timerin "+watcherin);
	System.out.println("=== Timerout "+watcherout);
	
	mutexes=new mutex[mutex.NUM_MUTEX];
	for(int x=0; x<mutex.NUM_MUTEX; x++) {
	    mutexes[x]=new mutex(x);
	}

	sep=new seperate();
	SchedulingParameters ssp=new PriorityParameters(MyThread.BASE_PRIO+
						       MyThread.NUM_THREADS+2);
	sep.setSchedulingParameters(ssp);
	sep.setReleaseParameters(pp);
	sep.addToFeasibility();

	System.out.println("*** Right before sep. start");

	sep.start();

	System.out.println("*** Right after sep.start");

	mt = new MyThread[MyThread.NUM_THREADS];

	MyAsyncEventHandler maeh;

	for(int x=0; x<MyThread.NUM_THREADS; x++) {

	    mt[x] = new MyThread(x, threadin, threadout, mutexes, mt, this);

	    maeh=new MyAsyncEventHandler(mt[x]);

	    pp=new PeriodicParameters(start, new RelativeTime(1000*MULT,0), 
				      new RelativeTime(50*MULT,0), 
				      new RelativeTime(1000*MULT,0), maeh, 
				      maeh);

	    SchedulingParameters sp=new PriorityParameters(
					         MyThread.BASE_PRIO+x);
	    mt[x].setSchedulingParameters(sp);
	    mt[x].setPrio(MyThread.BASE_PRIO+x);
	    mt[x].setReleaseParameters(pp);
	    mt[x].addToFeasibility();
	    System.out.println("sync_tester : Right before "+x+" run()");
	    
	    mt[x].trigger_edge.set(start.getMilliseconds(),
				   start.getNanoseconds());

	    mt[x].start();

	    System.out.println("sync_tester : After calling start() method "+
			       "for thread "+x);

	}

	while(quit!=1) {

	    int thread, message, modifier;

	    thread = b_read();
	    message = b_read();
	    if(message==MyThread.STARTING_RUN) {
		modifier=b_read();
		//System.out.println("starting it's run");
	    } else if(message==MyThread.ENDING_RUN) {
		modifier=b_read();
		//System.out.println("ending it's run");
		check_running_and_set();
	    } else if(message==MyThread.LOCKING) {
		modifier=b_read();
		//System.out.println("locking mutex "+modifier);
		check_running_and_set();
	    } else if(message==MyThread.UNLOCKING) {
		modifier=b_read();
		//System.out.println("unlocking mutex "+modifier);
	    }

	}

    }

}
