import java.lang.*;
import javax.realtime.*;
import com.timesys.*;

public class deadlinemiss{

	public class simpleRTThread extends RealtimeThread
	{

	    boolean missDeadline = true;

	    public simpleRTThread(SchedulingParameters scheduling,
			  ReleaseParameters release)
	    {
		super(scheduling, release);
	    }

	    public void run()
	    {
		long startTime = System.currentTimeMillis();
		int i,dc = 0;
		for (i= 0 ;i<20; i++)
		    {
			System.out.println("\t\t\t*** "+getName()+":"+(System.currentTimeMillis() - startTime));

			if (missDeadline)
			    {
				missDeadline = false;
				System.out.println("\n\n ** LOOPING to miss deadline at("+(System.currentTimeMillis() - startTime)+")\n\n");
				for (long k=0; k < 9999999; k++)
				    ;
			    }

			System.out.println("\n\n ** calling wfnp at("+(System.currentTimeMillis() - startTime)+")\n\n");

			if (!waitForNextPeriod())
			    {
			    System.out.println("\t\t\t** "+getName()+" waitForNextPeriod failed");
			    setScheduler(PriorityScheduler.instance());
			    //break;
			    }
		    }
		System.out.println(getName()+": DONE!! ");
	    }
	}
    
    private class DeadlineHdlr extends AsyncEventHandler
    {
	public RealtimeThread rtt;
	public AbsoluteTime startTime;
	
	public DeadlineHdlr(SchedulingParameters sp,
			    ReleaseParameters rp,
			    MemoryParameters mp,
			    MemoryArea ma,
			    ProcessingGroupParameters gp)
	{
	    super(sp,rp,mp,ma,gp, null);
	}

	public void handleAsyncEvent()
	{
	    System.out.println("\n\n\t\t\t\t\t ### Upss a deadline was missed at("+(System.currentTimeMillis() - startTime.getMilliseconds())+") :-(\n\n");
	    try
		{
		    Thread.sleep(5000);
		}
	    catch(Exception e)
		{
		}
	    rtt.schedulePeriodic();
	}
    }

	public static void main(String args[]){
		deadlinemiss s = new deadlinemiss();
		s.run();
	}

	public void run(){
	    System.out.println("starting");

	    DeadlineHdlr dh = new DeadlineHdlr(new PriorityParameters(PriorityScheduler.MAX_PRIORITY),null, null,null,null);
	    dh.setScheduler(PriorityScheduler.instance());

	    simpleRTThread rtt;
	    AbsoluteTime start = new AbsoluteTime(System.currentTimeMillis() + 10000,0);
	    RelativeTime period = new RelativeTime(5000,0);
	    RelativeTime cost   = new RelativeTime(100,0);
	    RelativeTime deadline = new RelativeTime(2000,0);
	    
	    PeriodicParameters sp = new PeriodicParameters(start, period, cost, deadline, null, dh);
	    
	    try 
		{
		System.out.println("About to fork the threads");
		rtt = new simpleRTThread((SchedulingParameters)null ,(ReleaseParameters)sp);
		rtt.setName("one");
		rtt.setScheduler(DMScheduler.instance());
		boolean res = rtt.addToFeasibility();
		dh.rtt = rtt;
		dh.startTime = start;
		System.out.println("before start");
		rtt.start();
			
		}
	    catch (Exception e)
		{
		    System.out.println(e);
		}
	}
}
