/*
 * @(#)float.h	1.6 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _ANSI_FLOAT_H
#define _ANSI_FLOAT_H

#include <math.h>		 /* fmod */

/*
 * See src/share/javavm/include/porting/float.h for full documentation.
 */

#define CVMfloatAdd(op1, op2)	((op1) + (op2))
#define CVMfloatSub(op1, op2)	((op1) - (op2))
#define CVMfloatMul(op1, op2)	((op1) * (op2))
#define CVMfloatDiv(op1, op2)	((op1) / (op2))

#ifdef USE_ANSI_FMOD
#define CVMfloatRem(op1, op2)	fmod((op1), (op2))
#endif

/*
 * Unary operations
 */

#define CVMfloatNeg(op)	(-(op))

/*
 * Float Comparisons (returning int value 0, 1, or -1) 
 */

#define CVMfloatCompare(op1, op2, opcode_value) \
    (((op1) < (op2)) ? -1 : \
     ((op1) > (op2)) ? 1 : \
     ((op1) == (op2)) ? 0 : \
     ((opcode_value) == -1 || (opcode_value) == 1) ? (opcode_value) :\
     0)

/*
 * Float Conversions:
 */

#define CVMfloat2Double(val)	((CVMJavaDouble)(val)) 

#define CVMfloat2Int(val)	(float2Int(val))

/*
 * JAVA_COMPLIANT_f2i, NAN_CHECK_f2i, or neither (but not both) may be
 * defined.
 *
 */

#ifdef JAVA_COMPLIANT_f2i

#define float2Int(val)    ((CVMJavaInt)(val))

#elif (defined(NAN_CHECK_f2i))

#define float2Int(val)    ((val) != (val) ? 0 : (CVMJavaInt)(val))

#else

extern CVMJavaInt float2Int(CVMJavaFloat d);

#endif

#endif /* _ANSI_FLOAT_H */
