/*
 * %W% %E%
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package javax.microedition.io;

import java.io.*;

/**
 * This interface defines the capabilities that a connection notifier
 * must have.
 *
 * @author  Nik Shaylor
 * @version 1.1 1/7/2000
 */
public interface StreamConnectionNotifier extends Connection {
    /**
     * Returns a <code>StreamConnection</code> that represents a server side
     * socket connection
     *
     * @return                  A socket to communicate with a client.
     * @exception  IOException  If an I/O error occurs.
     */
    public StreamConnection acceptAndOpen() throws IOException;
}
