/*
 * -----------------------------------------------------------------
 * jvmcei.h :
 *
 * Copyright (C) 2001 TimeSys Corporation, All Rights Reserved.
 *
 * This software is subject to the terms and conditions of the
 * accompanying Common Public License in file CPLicense.  Your use
 * of this software indicates your acceptance of these terms.
 * -----------------------------------------------------------------
 */



/* This is the header for the 
 * Timesys core extensions. It defines the set of functions that 
 * are available to a core extension 
 * Initial definition:
 * Dionisio de Niz
 * June 30, 2000
 */

/* Definition of filters */

/* Syntax convensions:
 * a prefix SYS means that the object created is a low level object 
 */

#ifndef _JVMCEI_
#define _JVMCEI_

typedef int (*intFuncPtr)(void *);


#define CEF_SIZE 18

#define JVMCEF_AFTER_CREATE_SYS_THREAD   0
#define JVMCEF_AFTER_DESTROY_SYS_THREAD  1
#define JVMCEF_BEFORE_DESTROY_SYS_THREAD 2
#define JVMCEF_AFTER_CREATE_OBJECT 3
#define JVMCEF_BEFORE_CREATE_MONITOR 4
#define JVMCEF_BEFORE_INIT_MONITOR 5
#define JVMCEF_BEFORE_FREE_MONITOR 6
#define JVMCEF_IS_HEAP_MEMORY            7
#define JVMCEF_INIT_EXECENV              8
#define JVMCEF_ALLOC_NEW_INSTANCE        9                              
#define JVMCEF_ALLOC_NEW_ARRAY           10
#define JVMCEF_GET_MEMORY_AREA           11
#define JVMCEF_SET_MEMORY_AREA           12
#define JVMCEF_GC_SCAN_ALL_MEMORY_AREAS  13
#define JVMCEF_GC_HANDLE_REFERENCE       14
#define JVMCEF_DESTROY_EXEC_ENV          15
#define JVMCEF_BEFORE_MONITOR_OPERATION  16
#define JVMCEF_BEFORE_CREATE_SYS_THREAD  17

#define FUNCPTRERROR (void *) -1
#define JVMCEI_CONTINUE_CURRENT_CALL 1
#define JVMCEI_ABORT_CURRENT_CALL 0
#define JVMCEI_ERROR -1

struct jvmcei_ext_str
{
  struct jvmcei_ext_str *nxt;
  int id;
  void * ext_data_ptr;
};

struct jvmcei
{
  void * (*installFilter) (long filterID, int (*function)(void *));
  void * (*allocMemory)(int size);
  void    (*freeMemory)(void *);
  void * (*allocLTMemory)(long size);
  int    (*freeLTMemory) (void *);
  void   (*addExtStruct) (struct jvmcei_ext_str **,struct jvmcei_ext_str *);
};

void jvmcei_initialize();

/* I have to do the following because of dependecies between 
 * jvmcei.h and jni.h. (which I have to do in order to get rid of 
 * a compilation warning).
 * - Pratik (26th July 2001)
 */
/*
#ifdef __cplusplus
extern struct JNIEnv;
#else
extern struct JNINativeInterface;
extern struct JNINativeInterface *JNIEnv;
#endif


void jvmcei_installAllFilters(JNIEnv *env);
*/

#endif
