/*
 * @(#)basictypes.h	1.12 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file gives some basic types, and some info associated with
 * basic types as defined by the VM spec 
 */
#ifndef _INCLUDED_BASICTYPES_H
#define _INCLUDED_BASICTYPES_H

#include "javavm/include/defs.h"
#include "javavm/include/typeid.h"

enum CVMBasicType {
    /*
     * These basic types are straight from the VM spec
     */
    CVM_T_CLASS = 2,
    CVM_T_BOOLEAN = 4,
    CVM_T_CHAR,
    CVM_T_FLOAT,
    CVM_T_DOUBLE,
    CVM_T_BYTE,
    CVM_T_SHORT,
    CVM_T_INT,
    CVM_T_LONG,
    CVM_T_VOID = 17
};

typedef enum CVMBasicType CVMBasicType;

/*
 * Now some data declarations
 */

/*
 * A mapping from basic type to size in bytes
 */
extern const CVMUint32 CVMbasicTypeSizes[];

/*
 * A mapping from basic type to one char signature
 */
extern const char CVMbasicTypeSignatures[];

/*
 * A mapping from basic type to FieldTypeID
 */
extern const CVMClassTypeID CVMbasicTypeID[];

/*
 * A mapping from basic type to primitive class for basic type
 */
extern const CVMClassBlock* const CVMbasicTypeClassblocks[];

/*
 * A mapping from basic type to array class of basic type 
 */
extern const CVMClassBlock* const CVMbasicTypeArrayClassblocks[];

/*
 * A mapping from terse type to primitive class for basic type
 */
extern const CVMClassBlock* const CVMterseTypeClassblocks[];

/*
 * A mapping from terse type to basic type
 */
extern const CVMBasicType CVMterseTypeBasicTypes[];

/*
 * A mapping from terse type to signature character. Only works for
 * typeids representing fields and only for primitive types.
 */
extern const char CVMterseTypePrimitiveSignatures[];

#endif /* _INCLUDED_BASICTYPES_H */

