/*
 * @(#)fixedspace.h	1.3 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file includes functions for 'fixedspace' allocation.
 */

#ifndef _INCLUDED_FIXEDSPACE_H
#define _INCLUDED_FIXEDSPACE_H

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/classes.h"
#include "javavm/include/stacks.h"
#include "javavm/include/gc/gc_impl.h"
#include "javavm/include/basictypes.h"

/*
 * Allocate fixedspace object of type 'cb'.
 */
extern CVMObjectICell*
CVMfixedAllocNewInstance(CVMExecEnv* ee, CVMClassBlock* cb);

/*
 * Allocate fixedspace array of length 'len'. The type of the array is arrayCb.
 * The elements are basic type 'typeCode'.
 */
extern CVMArrayOfAnyTypeICell*
CVMfixedAllocNewArray(CVMExecEnv* ee, CVMBasicType typeCode,
		      CVMClassBlock* arrayCb, CVMJavaInt len);

#endif /* _INCLUDED_FIXEDSPACE_H */
