/*
 * @(#)gen_semispace.h	1.7 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file includes the implementation of a copying semispace generation.
 */

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/classes.h"
#include "javavm/include/directmem.h"

/*
 * This file is generated from the GC choice given at build time.
 */
#include "generated/javavm/include/gc_config.h"

#include "javavm/include/gc_common.h"
#include "javavm/include/gc/gc_impl.h"

#include "javavm/include/gc/generational/generational.h"

typedef struct CVMGenSemispaceGeneration {
    CVMGeneration gen;
    CVMGenSpace*  fromSpace;     /* Semispace #1 */
    CVMGenSpace*  toSpace;       /* Semispace #2 */
    CVMUint32*    copyBase;      /* The base pointer for copying */
    CVMUint32*    copyTop;       /* The top pointer for copying */
    CVMUint32*    copyThreshold; /* The top pointer for copying */
} CVMGenSemispaceGeneration;

/*
 * Allocate a new one of these generations
 */
extern CVMGeneration* 
CVMgenSemispaceAlloc(CVMUint32* space, CVMUint32 totalNumBytes);

/*
 * Free one of these generations
 */
void
CVMgenSemispaceFree(CVMGenSemispaceGeneration* thisGen);
