/*
 * @(#)packages.h	1.5 00/07/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */


#ifndef _INCLUDED_PACKAGES_H
#define _INCLUDED_PACKAGES_H

#define CVM_PKGINFO_HASHSIZE 31	    /* Number of buckets */

/* Hash table used to keep track of loaded packages */
typedef struct CVMPackage CVMPackage;
struct CVMPackage {
    char *packageName;	    /* Package name */
    char *filename;	    /* Directory or JAR file loaded from */
    CVMPackage* next;       /* Next entry in hash table */
};

/*
 * Returns the package file name corresponding to the specified package
 * or class name, or null if not found.
 */
extern char*
CVMpackagesGetEntry(const char* name);

/*
 * Adds a new package entry for the specified class or package name and
 * corresponding directory or jar file name. If there was already an existing
 * package entry then it is replaced. Returns the previous entry or null if
 * none.
 */
extern CVMBool
CVMpackagesAddEntry(const char *name, const char *filename);

/*
 * Destroys package information on VM exit
 */
extern void
CVMpackagesDestroy();

#endif /* _INCLUDED_PACKAGES_H */
