/*
 * @(#)string.h	1.4 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_PORTING_ANSI_STRING_H
#define _INCLUDED_PORTING_ANSI_STRING_H

#include "javavm/include/porting/defs.h"
#include "javavm/include/porting/ansi/stddef.h"

/*
 * Porting layer for C library sorts of things
 */

/*
 * C library <string.h> routines
 *
 * Functions:
 *
 * void*    memset(void* s, int c, size_t n);
 * void*    memcpy(void* d, const void* s, size_t n);
 * void*    memmove(void* d, const void* s, size_t n);
 * int	    strcmp(const char* s1, const char* s2);
 * int	    strncmp(const char* s1, const char* s2, size_t n);
 * size_t   strlen(const char* s1);
 * char*    strcpy(char* dst, const char* src);
 * char*    strncpy(char* dst, const char* src, size_t n);
 * char*    strdup(const char* str);
 * char*    strcat(char* dst, const char* src);
 * char*    strncat(char* dst, const char* src, size_t n);
 * char*    strstr(const char* s1, const char* s2);
 * char*    strchr(const char* s, int c);
 * char*    strrchr(const char* s, int c);
 * long     strtol(const char *str, char **endptr, int base);
 *
 */

#include CVM_HDR_ANSI_STRING_H

#endif /* _INCLUDED_PORTING_ANSI_STRING_H */
