#include <stdlib.h>
#include "jvmcei.h"
#include "jni.h"
#include "javavm/include/interpreter.h"
#include "javavm/include/mem_registry.h"

#include "com_timesys_CoreExtension_RTThreadAdaptor.h"
#include "com_timesys_CoreExtension_HeapMemoryAdapter.h"
#include "com_timesys_CoreExtension_RTMonitorAdapter.h"

intFuncPtr JVMCeiFilters[CEF_SIZE];

void * installFilter(long filterID, int (*function)(void *))
{
  if (filterID < CEF_SIZE)
    {
      void * ret = JVMCeiFilters[filterID];
      JVMCeiFilters[filterID] = function;
      return ret;
    }
  else
    {
      return FUNCPTRERROR;
    }
}

void jvmcei_ext_str_add(struct jvmcei_ext_str **q, struct jvmcei_ext_str *e)
{
  if (*q == NULL)
    *q = e;
  else
    {
      struct jvmcei_ext_str *t = *q;
      while ( (t)->nxt != NULL)
	t = t->nxt;
      t->nxt = e;
    }
}

int JVMCeiInitialized = 0;

void jvmcei_initialize()
{
  int i;
  /* Initialize filter pointers */
  for (i=0; i< CEF_SIZE ; i++)
    {
      JVMCeiFilters[i] = NULL;
    }
  JVMCeiInitialized = 1;
}

void jvmcei_installAllFilters(JNIEnv *env)
{
    //extern const CVMObjectICell CVMID_nullICell;
    // Brute force method of installing filters.
   
    // First initialise the memory registery
    initialiseMemoryRegistry(CVMjniEnv2ExecEnv(env));
    
    // First call RTThreadAdaptor
    Java_com_timesys_CoreExtension_RTThreadAdaptor_bootNative(env, NULL);

    // Now call RTMonitorAdapter
    Java_com_timesys_CoreExtension_RTMonitorAdapter_bootNative(env, NULL);
    
    // Now call HeapMemoryAdapter
    Java_com_timesys_CoreExtension_HeapMemoryAdapter_bootNative(env, NULL, NULL);

    JVMCeiInitialized = 1;
}


extern void * sysMalloc(int);
extern void sysFree(void *);

const struct jvmcei JVMCei= {
  installFilter,
  NULL,
  NULL,
  NULL,
  NULL,
  jvmcei_ext_str_add,
};






