/*
 * @(#)DMArrayRWShortTest.c	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/export/jvm.h"
#include "javavm/export/jni.h"
#include "native/common/jni_util.h"
#include "javavm/include/interpreter.h"
#include "javavm/include/gc_common.h"
#include "javavm/include/porting/threads.h"
#include "javavm/include/porting/time.h"
#include "javavm/include/porting/int.h"
#include "javavm/include/porting/doubleword.h"
#include "javavm/include/clib.h"
#include "javavm/include/indirectmem.h"
#include "javavm/include/directmem.h"
#include "javavm/include/globalroots.h"
#include "javavm/include/localroots.h"
#include "javavm/include/preloader.h"
#include "javavm/include/common_exceptions.h"
#include "generated/offsets/java_lang_Class.h"
#include "generated/offsets/java_lang_Thread.h"
#include "generated/offsets/java_lang_Throwable.h"
#include "generated/jni/java_lang_reflect_Modifier.h"
#include <stdio.h>
#include "DMArrayRWShortTest.h"


JNIEXPORT void JNICALL
Java_DMArrayRWShortTest_nSetArray(JNIEnv *env, jobject obj, 
                              jshortArray dstArray, jshortArray srcArray, jint arrayLength)
{
   jint i;
   jshort val;
   jobject lock;
   jfieldID iFid, oFid;
   jclass gcClazz, testClazz;
   CVMExecEnv *ee;

   gcClazz = (*env)->FindClass(env, "GcThread");
   iFid = (*env)->GetStaticFieldID(env, gcClazz, "gcCalled", "I");

   testClazz = (*env)->GetObjectClass(env, obj);
   oFid = (*env)->GetStaticFieldID(env, testClazz, "lock", "Ljava/lang/Object;");
   lock = (*env)->GetStaticObjectField(env, testClazz, oFid);

   ee = CVMjniEnv2ExecEnv(env);

   CVMD_gcUnsafeExec( ee, {
      CVMArrayOfShort* directSrcArray = (CVMArrayOfShort *)CVMID_icellDirect(ee, srcArray);
      CVMArrayOfShort* directDstArray = (CVMArrayOfShort *)CVMID_icellDirect(ee, dstArray);
      jint rBarrier = 0;
      jint wBarrier = 0;

      CVMfbStaticField(iFid).i = -1;

      CVMobjectLock(ee, lock);
      CVMobjectNotify(ee, lock);
      CVMobjectUnlock(ee, lock);

      for(i = 0; i < 1000000; i++)
         ;

     for(i=0; i<arrayLength; i++) {
      CVMD_arrayReadShort(directSrcArray, i, val);
      if(ee->barrier == R_BARRIER_SHORT)
         rBarrier++;
      CVMD_arrayWriteShort(directDstArray, i, val);
      if(ee->barrier == W_BARRIER_SHORT)
         wBarrier++;
     }

      if(rBarrier == arrayLength && wBarrier == arrayLength)
         printf("PASS: DMArrayRWShortTest, Read & Write Barrier Short were invoked\n");
      else
         printf("FAIL: DMArrayRWShortTest, Read & Write Barrier Short were not invoked\n");

      printf("\n");
       
      if(CVMfbStaticField(iFid).i == -1)
         printf("PASS: DMArrayRWShortTest, Gc did not happen in the gc unsafe section\n");
      else
         printf("FAIL: DMArrayRWShortTest, Gc happened in the gc unsafe section\n");
   } );
}
