/*
 * @(#)DMArrayCopyFloatTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayCopyFloatTest extends Thread {

   private float [] privateArray;
   public static Object lock;

   public DMArrayCopyFloatTest(int num) {
      privateArray = new float[num];
   }

   private native void nSetArray(float [] srcArray, float [] dstArray);

   public void setArray(float [] srcArray) {
	this.nSetArray(srcArray, this.privateArray);
   }

   public float getArrayElement(int index) {
      return(privateArray[index]);
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      System.out.println();

      float [] floatArray = new float[arrayLength];
      for(int i=0; i<arrayLength; i++)
         floatArray[i] = rd.nextFloat();

      setArray(floatArray);

      for(int i=0; i<arrayLength; i++) {
         if(getArrayElement(i) != floatArray[i]) {
            pass = false;	
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayCopyFloatTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayCopyFloatTest, Data written and read were not same");
   }

   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayCopyFloatTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayCopyFloatTest test = new DMArrayCopyFloatTest(rd.nextInt(100)); 

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
