/*
 * @(#)DMArrayCopyIntTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayCopyIntTest extends Thread {

   private int [] privateArray;
   public static Object lock;

   public DMArrayCopyIntTest(int num) {
      privateArray = new int[num];
   }

   private native void nSetArray(int [] srcArray, int [] dstArray);

   private int getArrayElement(int index) {
      return(privateArray[index]);
   }

   public void setArray(int [] srcArray) {
	this.nSetArray(srcArray, this.privateArray);
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      System.out.println();

      int [] intArray = new int[arrayLength];
      for(int i=0; i<arrayLength; i++)
         intArray[i] = rd.nextInt();

      setArray(intArray);

      for(int i=0; i<arrayLength; i++) {
         if(getArrayElement(i) != intArray[i]) {
            pass = false;	
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayCopyIntTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayCopyIntTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayCopyIntTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayCopyIntTest test = new DMArrayCopyIntTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
