/*
 * @(#)DMFieldRWRefTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMFieldRWRefTest extends Thread {

   private String publicString;
   private String protectedString;
   private String privateString;
   public static Object lock;

   public DMFieldRWRefTest() {
      publicString = null;
      protectedString = null;
      privateString = null;
   }

   public native void nSetStrings(String str1, String str2, String str3);

   public native String [] nGetStrings();

   public String [] getStrings() {
      String [] strArray = {publicString, protectedString, privateString};
      return strArray;
   }

   public void run () {
      boolean pass=true;
      Random rd = new Random();
      String [] str = {String.valueOf(rd.nextInt()), String.valueOf(rd.nextInt()),String.valueOf(rd.nextInt())};

      System.out.println();

      nSetStrings(str[0], str[1], str[2]);

      System.out.println();

      String [] strArray1 = getStrings();
      String [] strArray2 = nGetStrings();

      if(strArray1.length == strArray2.length) {
         for(int i=0; i<strArray1.length; i++) {
            if(strArray1[i].compareTo(strArray2[i]) != 0) {
               pass = false;
               break;
            }
         }
      }
      else {
         pass = false;
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMFieldRWRefTest, Data written and read were same");
      else
         System.out.println("FAIL: DMFieldRWRefTest, Data written and read were not same");

   }

   public static void main(String args[]) {
      Object lck = new Object();

      DMFieldRWRefTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMFieldRWRefTest test = new DMFieldRWRefTest();

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }
}
