/*
 * @(#)ReflectionStackOverflowTest.java	1.2 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
import java.lang.reflect.*;

/** Verify that we throw StackOverflowErrors properly when
  Method.invoke() is used recursively, as per Java bug #4217960 which
  Dean filed against JDK 1.2 in March. */

public class ReflectionStackOverflowTest {

    static int depth = 0;
    static Method m;

    public static void test(Method m) throws Throwable {
        ++depth;
	if ((depth % 1000) == 0)
	    System.err.println("Test at depth " + depth);

        Object[] args = {m};
        try {
            m.invoke(null, args);
        } catch (InvocationTargetException e) {
            throw e.getTargetException();
        }
    }

    public static void main(String[] args) {
	try {
            Class c = ReflectionStackOverflowTest.class;
            Class[] sig = {Method.class};
            m = c.getMethod("test", sig);
            test(m);
	}
	catch (StackOverflowError e) {
	    System.out.println("Stack overflow error successfully detected");
	}
	catch (Throwable e) {
	    e.printStackTrace();
	    System.out.println("ERROR: Some other exception caught");
	}
    }
}
