/*
 * @(#)ThreadsAndSync.java	1.4 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

public class ThreadsAndSync {

    public static void main(String argv[]) {
	System.out.print("Starting test1\n");
	test0();
	test1();
    }

    static void test0() {
        final Object lock = new Object();
        Thread thr = new Thread() {

            public void run() {
                while (true) {
                    synchronized (lock) {
                        Thread.yield();
                    }
                }
            }
        };

        thr.start();

        while (true) {
            synchronized (lock) {
                Thread.yield();
            }
        }
    }

    static void test1() {
	Thread thr = new Thread() {

	    public void run() {
		float y = (float)1.0;

		System.out.print("calling Thread.yield()\n");
		Thread.yield();

		y = (float)2.0;

		System.out.print("calling Thread.yield()\n");
		Thread.yield();

		y = (float)3.0;
	    }
	};

	thr.start();
	int x = 1;
	Thread.yield();
	x = 2;
	Thread.yield();
	x = 3;
	Thread.yield();
	Thread me = Thread.currentThread();
	if (thr == me) {
	    // impossible
	    throw new RuntimeException();
	}
	x = 4;
    }

}
