/*
 * @(#)JDKVM.java	1.2 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package vm;
import components.*;
import Const;
import DataFormatException;

/*
 * This code knows information about the JDK1.x virtual machine
 * that is not really platform-specific. Extend this class to
 * make a core-image writer for your platform.
 */

public class JDKVM {

    public static boolean staticMember( ClassMemberInfo f ){
	return ( (f.access & Const.ACC_STATIC) != 0 );
    }

    public static boolean privateMember( ClassMemberInfo f ){
	return ( (f.access & Const.ACC_PRIVATE) != 0 );
    }

    public static boolean isClassType( FieldInfo f ){
	char t = f.type.string.charAt(0);
	return ( ( t == Const.SIGC_ARRAY ) || ( t == Const.SIGC_CLASS ));
    }

    public static boolean needsExtraStorage( FieldInfo f ){
        return true;
    }

    public static boolean isDataPure( FieldInfo f[] ){
	return true;
    }


}
