/*
 * @(#)java_props.h	1.6 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _JAVA_PROPS_H
#define _JAVA_PROPS_H

typedef struct {
    const char *os_name;
    const char *os_version;
    const char *os_arch;

    const char *tmp_dir;
    const char *font_dir;
    const char *user_dir;

    const char *file_separator;
    const char *path_separator;
    const char *line_separator;

    const char *user_name;
    const char *user_home;

    const char *language;
    const char *encoding;
    const char *region;
    const char *timezone;

    const char *printerJob;
    const char *graphics_env;
    const char *awt_toolkit;

    const char *unicode_encoding;	/* The default endianness of unicode
					   i.e. UnicodeBig or UnicodeLittle   */

    const char *cpu_isalist;            /* list of supported instruction sets */

    const char *cpu_endian;             /* endianness of platform */
    
    /*
     * More platform-dependent entries (used to be props_md_t in JDK 1.3)
     */
    const char *sysclasspath;   /* Location of trusted "system" classes */
    const char *library_path;
    const char *dll_dir;
    const char *java_home;
    const char *ext_dirs;
} java_props_t;

/*
 * Get platform dependent system properties
 */
void CVMgetJavaProperties(java_props_t *props);

#endif /* _JAVA_PROPS_H */
