/*
 * @(#)defs_md.h	1.9 00/08/29
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file declares basic types. These are C types with the width
 * encoded in a one word name, and a mapping of Java basic types to C types.
 *
 */

#ifndef _VXWORKS_DEFS_MD_H
#define _VXWORKS_DEFS_MD_H

/*
 * VxWorks uses types common to gcc
 */

#include <porting/gcc_32_bit/defs.h>

#define CVM_HDR_ANSI_LIMITS_H	<limits.h>
#define CVM_HDR_ANSI_STDIO_H	<stdio.h>
#define CVM_HDR_ANSI_STDARG_H	<stdarg.h>
#define CVM_HDR_ANSI_STDDEF_H	<stddef.h>
#define CVM_HDR_ANSI_STDLIB_H	<stdlib.h>
#define CVM_HDR_ANSI_TIME_H	<time.h>
#define CVM_HDR_ANSI_ASSERT_H	<assert.h>

#define CVM_HDR_ANSI_CTYPE_H	"javavm/include/ctype_md.h"
#define CVM_HDR_ANSI_SETJMP_H	"javavm/include/setjmp_md.h"
#define CVM_HDR_ANSI_STRING_H	"javavm/include/string_md.h"
#define CVM_HDR_ANSI_ERRNO_H	"javavm/include/errno_md.h"

#define CVM_HDR_INT_H		"javavm/include/int_md.h"
#define CVM_HDR_FLOAT_H		"javavm/include/float_md.h"
#define CVM_HDR_DOUBLEWORD_H	"javavm/include/doubleword_md.h"
#define CVM_HDR_JNI_H		"javavm/include/jni_md.h"
#define CVM_HDR_GLOBALS_H	"javavm/include/globals_md.h"
#define CVM_HDR_THREADS_H	"javavm/include/threads_md.h"
#define CVM_HDR_SYNC_H		"javavm/include/sync_md.h"
#define CVM_HDR_LINKER_H	"javavm/include/defs_md.h" /* no-op */
#define CVM_HDR_PATH_H		"javavm/include/path_md.h"
#define CVM_HDR_IO_H		"javavm/include/io_md.h"
#define CVM_HDR_NET_H		"javavm/include/net_md.h"
#define CVM_HDR_TIME_H		"javavm/include/time_md.h"
#define CVM_HDR_ENDIANNESS_H	"javavm/include/endianness_md.h"
#define CVM_HDR_SYSTEM_H	"javavm/include/defs_md.h" /* no-op */

#define CVM_ADV_SCHEDLOCK
#define CVM_ADV_MUTEX_SET_OWNER

#undef CVM_HAVE_PROCESS_MODEL

#endif /* _VXWORKS_DEFS_MD_H */
