/*
 * @(#)threads_md.h	1.25 00/11/13
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
/*
 * Machine-dependent thread definitions.
 */

#ifndef _VXWORKS_THREADS_MD_H
#define _VXWORKS_THREADS_MD_H

#include "javavm/include/porting/sync.h"
#include "javavm/include/porting/globals.h"
#include "javavm/include/porting/ansi/setjmp.h"

struct CVMThreadID {
    int taskID;
    void *stackTop;
    /* support for CVMmutexSetOwner */
    CVMMutex *targetMutex;
    int lastPriority;
    CVMMutex setOwnerLock;
    SEM_ID setownerCV;
    /* support for Thread.interrupt() */
    CVMBool in_wait;
    CVMBool interrupted;
    jmp_buf env;
};

#define CVM_THREAD_MIN_C_STACK_SIZE                             (32 * 1024)

#define CVM_REDZONE_ILOOP                                       11592 /* 11.32KB */
#define CVM_REDZONE_CVMimplementsInterface                       4752 /*  5.14KB */
#define CVM_REDZONE_CVMCstackCVMpc2string                        4752 /*  5.14KB */
#define CVM_REDZONE_CVMCstackCVMID_objectGetClassAndHashSafe     5392 /*  5.27KB */
#define CVM_REDZONE_CVMclassLookupFromClassLoader               13500 /* 13.18KB */
#define CVM_REDZONE_CVMclassLink                                 7456 /*  7.28KB */
#define CVM_REDZONE_CVMCstackmerge_fullinfo_to_types             5800 /*  5.66KB */
#define CVM_REDZONE_CVMsignalErrorVaList                         8400 /*  8.20KB */

#ifdef VXWORKS_PRIVATE
extern void threadInitStaticState();
extern void threadDestroyStaticState();
#endif

#endif /* _VXWORKS_THREADS_MD_H */
