/*
 * @(#)fp_md.c	1.3 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/include/porting/doubleword.h"
#include "javavm/include/porting/float.h"
#include <vxWorks.h>
#include <math.h>
#include <string.h>


double
doubleRem(double op1, double op2) {
    if (op1 == (1.0 / 0.0) || op1 == (-1.0 / 0.0)	/* Inf or -Inf */
	|| op2 == 0.0 || op2 == -0.0)
    {
	return (0.0 / 0.0);	/* NaN */
    } else {
        long long lres, lop1, rlli, olli;
        long rli, oli;

	double res = fmod(op1, op2);

	/* sign must match dividend */
        bcopy((void *)&res, (void *)&lres, 8);
        rlli = (long long)lres >> 63;
        rli = (long) rlli & 0x00000001;

        bcopy((void *)&op1, (void *)&lop1, 8);
        olli = (long long)lop1 >> 63;
        oli = (long) olli & 0x00000001;

        if (res == res && rli != oli) {
            res = -res;
        }
	return res;
    }
}

float
floatRem(float op1, float op2) {
    if (op1 == (1.0 / 0.0) || op1 == (-1.0 / 0.0)	/* Inf or -Inf */
	|| op2 == 0.0 || op2 == -0.0)
    {
	return (0.0 / 0.0);	/* NaN */
    } else {
        long lres, lop1, rli, oli;
	float res = fmod(op1, op2);

	/* sign must match dividend */
        bcopy((void *)&res, (void *)&lres, 4);
        rli = lres >> 31;
        rli = rli & 0x00000001;

        bcopy((void *)&op1, (void *)&lop1, 4);
        oli = lop1 >> 31;
        oli = oli & 0x00000001;

        if (res == res && rli != oli) {
            res = -res;
        }
	return res;
    }
}
