/*
 * %W% %E%
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package javax.microedition.io;

import java.io.*;

/**
 * This is the most basic type of generic connection. Only the close
 * method is defined. The open method defined here because opening is
 * always done by the Connector.open() methods.
 *
 * @author  Nik Shaylor
 * @version 1.1 1/25/2000
 */
public interface Connection {

    /**
     * Close the connection.
     * <p>
     * When the connection has been closed access to all methods except this one
     * will cause an an IOException to be thrown. Closing an already closed
     * connection has no effect. Streams derived from the connection may be open
     * when method is called. Any open streams will cause the
     * connection to be held open until they themselves are closed.
     *
     * @exception IOException  If an I/O error occurs
     */
    public void close() throws IOException;
}
