/*
 * @(#)bcattr.h	1.7 00/09/06
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * The byte-code attributes (bcAttr) interface. Used for inquiring about
 * various opcode properties.
 */

#ifndef _INCLUDED_BCATTR_H
#define _INCLUDED_BCATTR_H

extern const char CVMbcAttributes[256];

#define CVM_BC_ATT_BIT(x)             (1 << (x))

#define CVM_BC_ATT_GCPOINT            CVM_BC_ATT_BIT(0)
#define CVM_BC_ATT_BRANCH             CVM_BC_ATT_BIT(1)
#define CVM_BC_ATT_THROWSEXCEPTION    CVM_BC_ATT_BIT(2)
#define CVM_BC_ATT_NOCONTROLFLOW      CVM_BC_ATT_BIT(3)
#define CVM_BC_ATT_INVOCATION         CVM_BC_ATT_BIT(4)
#define CVM_BC_ATT_COND_GCPOINT       CVM_BC_ATT_BIT(5)

#define CVMbcAttr(opcode, attr) \
    ((CVMbcAttributes[(opcode)] & CVM_BC_ATT_##attr) != 0)

#endif /* _INCLUDED_BCATTR_H */
