/*
 * @(#)common_exceptions.h	1.30 00/07/05
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * Common exceptions thrown from within JVM.  Add more here as you
 * find uses of SignalError. (Help the next guy avoid typos.)
 *
 * NATIVE LIBRARIES MUST NOT USE THESE ROUTINES.
 */

#ifndef _JAVASOFT_COMMON_EXCEPTIONS_H_
#define _JAVASOFT_COMMON_EXCEPTIONS_H_

typedef void CVMThrowFunc(CVMExecEnv *, const char *format, ...);


#ifdef CVM_CLASSLOADING
extern CVMThrowFunc CVMthrowClassCircularityError;
extern CVMThrowFunc CVMthrowClassFormatError;
extern CVMThrowFunc CVMthrowIllegalAccessError;
extern CVMThrowFunc CVMthrowInstantiationError;
extern CVMThrowFunc CVMthrowLinkageError;
extern CVMThrowFunc CVMthrowUnsupportedClassVersionError;
extern CVMThrowFunc CVMthrowVerifyError;
#endif

/* NOTE: CVM_CLASSLOADING and CVM_JVMDI both imply
   CVM_DYNAMIC_LINKING is defined; see build/share/defs.mk. */
#ifdef CVM_DYNAMIC_LINKING
extern CVMThrowFunc CVMthrowUnsatisfiedLinkError;
#endif

#ifdef CVM_REFLECT
extern CVMThrowFunc CVMthrowNegativeArraySizeException;
extern CVMThrowFunc CVMthrowNoSuchFieldException;
extern CVMThrowFunc CVMthrowNoSuchMethodException;
#endif

#if defined(CVM_CLASSLOADING) || defined(CVM_REFLECT)
extern CVMThrowFunc CVMthrowIncompatibleClassChangeError;
#endif

extern CVMThrowFunc CVMthrowAbstractMethodError;
extern CVMThrowFunc CVMthrowArithmeticException;
extern CVMThrowFunc CVMthrowArrayIndexOutOfBoundsException;
extern CVMThrowFunc CVMthrowArrayStoreException;
extern CVMThrowFunc CVMthrowClassCastException;
extern CVMThrowFunc CVMthrowClassNotFoundException;
extern CVMThrowFunc CVMthrowCloneNotSupportedException;
extern CVMThrowFunc CVMthrowIllegalAccessException;
extern CVMThrowFunc CVMthrowIllegalArgumentException;
extern CVMThrowFunc CVMthrowIllegalMonitorStateException;
extern CVMThrowFunc CVMthrowInstantiationException;
extern CVMThrowFunc CVMthrowInternalError;
extern CVMThrowFunc CVMthrowInterruptedException;
extern CVMThrowFunc CVMthrowNoClassDefFoundError;
extern CVMThrowFunc CVMthrowNoSuchFieldError;
extern CVMThrowFunc CVMthrowNoSuchMethodError;
extern CVMThrowFunc CVMthrowNullPointerException;
extern CVMThrowFunc CVMthrowOutOfMemoryError;
extern CVMThrowFunc CVMthrowStackOverflowError;
extern CVMThrowFunc CVMthrowStringIndexOutOfBoundsException;
extern CVMThrowFunc CVMthrowUnsupportedOperationException;

extern CVMThrowFunc CVMthrowInvalidClassException;
extern CVMThrowFunc CVMthrowIOException;

/* *** RTSJ *** */
extern CVMThrowFunc CVMthrowIllegalAssignmentError;
extern CVMThrowFunc CVMthrowMemoryAccessError;
extern CVMThrowFunc CVMthrowResourceLimitError;
extern CVMThrowFunc CVMthrowInaccessibleAreaException;
/* *** JSTR *** */

#endif /* !_JAVASOFT_COMMON_EXCEPTIONS_H_ */
