/*
 * @(#)gc_config.h	1.7 00/10/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file includes the configuration of the semi-space copying
 * collector 
 */

#ifndef _INCLUDED_SEMISPACE_GC_CONFIG_H
#define _INCLUDED_SEMISPACE_GC_CONFIG_H

#include "javavm/include/gc/gc_impl.h"
#include "javavm/include/gc/semispace/semispace.h"

#ifdef CVM_TEST_GC
typedef enum {
    R_BARRIER_BYTE=0,
    R_BARRIER_BOOLEAN,
    R_BARRIER_SHORT,
    R_BARRIER_CHAR,
    R_BARRIER_INT,
    R_BARRIER_FLOAT,
    R_BARRIER_REF,
    R_BARRIER_64,
    W_BARRIER_BYTE,
    W_BARRIER_BOOLEAN,
    W_BARRIER_SHORT,
    W_BARRIER_CHAR,
    W_BARRIER_INT,
    W_BARRIER_FLOAT,
    W_BARRIER_REF,
    W_BARRIER_64,
} CVMBarrierType;

#define CVMgcimplReadBarrierByte(directObj, slotAddr) \
        CVMgetEE()->barrier = R_BARRIER_BYTE;
#define CVMgcimplReadBarrierBoolean(directObj, slotAddr) \
        CVMgetEE()->barrier = R_BARRIER_BOOLEAN;
#define CVMgcimplReadBarrierShort(directObj, slotAddr) \
        CVMgetEE()->barrier = R_BARRIER_SHORT;
#define CVMgcimplReadBarrierChar(directObj, slotAddr) \
        CVMgetEE()->barrier = R_BARRIER_CHAR;
#define CVMgcimplReadBarrierInt(directObj, slotAddr) \
        CVMgetEE()->barrier = R_BARRIER_INT;
#define CVMgcimplReadBarrierFloat(directObj, slotAddr) \
        CVMgetEE()->barrier = R_BARRIER_FLOAT;
#define CVMgcimplReadBarrierRef(directObj, slotAddr) \
        CVMgetEE()->barrier = R_BARRIER_REF;
#define CVMgcimplReadBarrier64(directObj, slotAddr) \
        CVMgetEE()->barrier = R_BARRIER_64;

#define CVMgcimplWriteBarrierByte(directObj, slotAddr, rhsValue) \
        CVMgetEE()->barrier = W_BARRIER_BYTE;
#define CVMgcimplWriteBarrierBoolean(directObj, slotAddr, rhsValue) \
        CVMgetEE()->barrier = W_BARRIER_BOOLEAN;
#define CVMgcimplWriteBarrierShort(directObj, slotAddr, rhsValue) \
        CVMgetEE()->barrier = W_BARRIER_SHORT;
#define CVMgcimplWriteBarrierChar(directObj, slotAddr, rhsValue) \
        CVMgetEE()->barrier = W_BARRIER_CHAR;
#define CVMgcimplWriteBarrierInt(directObj, slotAddr, rhsValue) \
        CVMgetEE()->barrier = W_BARRIER_INT;
#define CVMgcimplWriteBarrierFloat(directObj, slotAddr, rhsValue) \
        CVMgetEE()->barrier = W_BARRIER_FLOAT;
#define CVMgcimplWriteBarrierRef(directObj, slotAddr, rhsValue) \
        CVMgetEE()->barrier = W_BARRIER_REF;
#define CVMgcimplWriteBarrier64(directObj, slotAddr, location_) \
        CVMgetEE()->barrier = W_BARRIER_64;
#endif

/* 
 * Global state specific to GC 
 */
struct CVMGCGlobalState {
    CVMUint32  heapSize;
    CVMSsHeap* heap;
};

/*
 * an example override of an array copy routine.
 */
#if OVERRIDE_BASIC_ARRAY_COPY
#define CVMgcimplArrayCopyInt(srcArr, srcIdx, dstArr, dstIdx, len) \
    memmove((void*)((dstArr)->elems + dstIdx), \
	    (const void *)((srcArr)->elems + srcIdx), \
	    (len) * sizeof(CVMJavaInt))
#endif

#endif /* _INCLUDED_SEMISPACE_GC_CONFIG_H */
