/*
 * @(#)stackmaps.h	1.10 00/10/25
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_STACKMAPS_H
#define _INCLUDED_STACKMAPS_H

/*
 * The types of errors that may occur during stackmap generation 
 */
typedef enum CVMMapError {
    CVM_MAP_SUCCESS,
    CVM_MAP_OUT_OF_MEMORY,
    CVM_MAP_EXCEEDED_LIMITS, /* branch too long or too many vars
				during rewrite */
} CVMMapError;

/*
 * Rewrite method as required prior to stackmap generation.
 * This allows us to defer generation until need, assured that
 * there will be no conflicts, and no need for rewriting, when
 * we do. CVM_TRUE on success, CVM_FALSE otherwise
 */
extern CVMMapError
CVMstackmapDisambiguate( CVMMethodBlock* mb, CVMBool didJSRscan );

/*
 * Compute stackmaps and store. CVM_TRUE on success, CVM_FALSE otherwise
 */
extern CVMBool
CVMstackmapCompute(CVMMethodBlock* mb,
		   CVMBool doConditionalGcPoints);

/*
 * Get the stackmap data for a given PC. This is a 16-bit PC value,
 * followed by a bunch of 16-bit chunks.
 */
extern CVMStackMapEntry*
CVMstackmapGetEntryForPC(CVMStackMaps* smaps, CVMUint16 pc);

/*
 * Initialization and destruction routines
 */
extern void
CVMstackmapComputerInit();

extern void
CVMstackmapComputerDestroy();

#endif /* _INCLUDED_STACKMAPS_H */
