/*
 * @(#)stackwalk.h	1.7 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _INCLUDED_STACKWALK_H
#define _INCLUDED_STACKWALK_H

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/stacks.h"

struct CVMStackWalkContext {
    CVMFrame*      frame;     /* The current frame of the walk */
    CVMStackChunk* chunk;     /* The last chunk of the current frame */
};

/*
 * Initialize and destroy a stack-walker context
 */
extern void
CVMstackwalkInit(CVMStack* stack, CVMStackWalkContext* c);

extern void
CVMstackwalkDestroy(CVMStackWalkContext* c);

/*
 * Go to the previous frame
 */
extern void
CVMstackwalkPrev(CVMStackWalkContext* c);

#endif /* _INCLUDED_STACKWALK_H */
