/*
 * @(#)weakrefs.h	1.9 00/09/29
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

/*
 * This file includes functions that are pertinent to weak reference
 * handling.
 */

#ifndef _INCLUDED_GC_WEAKREFS_H
#define _INCLUDED_GC_WEAKREFS_H

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/classes.h"
#include "javavm/include/stacks.h"
#include "javavm/include/gc/gc_impl.h"
#include "generated/offsets/java_lang_ref_Reference.h"

/*
 * Initializing the weakref module
 */
extern void
CVMweakrefInit();

/*
 * Discover a new weak reference instance
 */
extern void
CVMweakrefDiscover(CVMExecEnv* ee, CVMObject* weakRef);

/*
 * Process weak references that don't have strong references to them.
 */
extern void
CVMweakrefProcessNonStrong(CVMExecEnv* ee,
			   CVMRefLivenessQueryFunc isLive,
			   void* isLiveData,
			   CVMRefCallbackFunc transitiveScanner,
			   void* transitiveScannerData,
			   CVMGCOptions* gcOpts);

/*
 * Update weak references 
 */
void
CVMweakrefUpdate(CVMExecEnv* ee,
		 CVMRefCallbackFunc refUpdate, void* updateData,
		 CVMGCOptions* gcOpts);

/*
 * This is used to get a named field of a java.lang.ref.Referemce subclass
 */
#define CVMweakrefFieldAddr(weakRef, fieldName) \
    ((CVMObject**)(weakRef) + CVMoffsetOfjava_lang_ref_Reference_##fieldName)

#define CVMweakrefField(weakRef, fieldName) \
    *CVMweakrefFieldAddr(weakRef, fieldName)

#endif /* _INCLUDED_GC_WEAKREFS_H */
