/*
 * @(#)ClassDependenceNode.java	1.5 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package dependenceAnalyzer;
import util.Set;

/*
 * A concrete subclass of DependenceNode for use by
 * the ClassDependenceAnalyzer. This is not used by JavaFilter or
 * by JavaCodeCompact. It is for use by other dependence analysis
 * tools, which might operate on a more course-grained basis.
 * See DependenceNodeAnalyzer for a full example of use.
 */

public
class ClassDependenceNode extends DependenceNode {
    // flag values
    public static int EXCLUDED = 1;
    public static int INCLUDED = 2;

    public ClassDependenceNode superClass;
    public Set		       interfacesImplemented;

    /**
     * The name of a ClassDependenceNode is simply the
     * fully-qualified class name as a String, using
     * / as name component separator.
     * (Other DependenceNode types may have more intricate names.)
     */
    public ClassDependenceNode( Object classname ){
	super( classname );
    }
}
