/*
 * @(#)JDKClassFactory.java	1.4 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

package vm;
import Const;
import components.ConstantPool;
import components.ClassInfo;
import java.util.Hashtable;

public class JDKClassFactory implements VMClassFactory{
    
    public ClassClass newVMClass( ClassInfo c ){
	return new JDKClass( c );
    }

    private static boolean
    setType( String name, int value ){
	ClassInfo ci = ClassInfo.lookupClass( name );
	ClassClass cc;
	if ( (ci == null) || ( ( cc = ci.vmClass ) == null) ) return false;
	((JDKClass)cc).typeCode = value;
	return true;


    }

    public void
    setTypes(){
	setType( /*NOI18N*/"java/lang/Void", Const.T_VOID );
	setType( /*NOI18N*/"java/lang/Boolean", Const.T_BOOLEAN );
	setType( /*NOI18N*/"java/lang/Character", Const.T_CHAR );
	setType( /*NOI18N*/"java/lang/Byte", Const.T_BYTE );
	setType( /*NOI18N*/"java/lang/Short", Const.T_SHORT );
	setType( /*NOI18N*/"java/lang/Integer", Const.T_INT );
	setType( /*NOI18N*/"java/lang/Long", Const.T_LONG );
	setType( /*NOI18N*/"java/lang/Float", Const.T_FLOAT );
	setType( /*NOI18N*/"java/lang/Double", Const.T_DOUBLE );
    }

    public ConstantPool 
    makeResolvable(ConstantPool cp, Hashtable missingClasses) {
	//
        // we use a LocalConstantPool to manage the pool we're re-building.
        // Because order matters, we collect the new entries to add at end.
        //
        System.err.println(Localizer.getString("classclass.warning_it_has_an_impure_shared_constant_pool"));
	return JDKClass.makeResolvable(cp.getConstants(), missingClasses);
    }
}
