/*
 * @(#)named_sys_monitor.c	1.3 00/09/07
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#include "javavm/include/defs.h"
#include "javavm/include/interpreter.h"
#include "javavm/include/named_sys_monitor.h"
#include "javavm/include/clib.h"

#if (defined(CVM_JVMDI) || defined(CVM_JVMPI))

/*=============================================== class CVMNamedSysMonitor ==*/

/* Purpose: Computes the size of an instance of the monitor. */
/* inline static CVMUint32 CVMnamedSysMonitorComputeSize(const char *name); */
#define CVMnamedSysMonitorComputeSize(name) \
    (CVMoffsetof(CVMNamedSysMonitor, name) + strlen(name) + 1)

/* Purpose: Constructor. */
CVMNamedSysMonitor *CVMnamedSysMonitorInit(const char *name)
{
    CVMNamedSysMonitor *monitor = malloc (CVMnamedSysMonitorComputeSize(name));
    CVMsysMonitorInit(&monitor->_super, NULL, 0);
    strcpy (monitor->name, name);
    return monitor;
}

/* Purpose: Destructor. */
void CVMnamedSysMonitorDestroy(CVMNamedSysMonitor *self)
{
    CVMsysMonitorDestroy(&self->_super);
    free (self);
}

#endif

