/*
 * @(#)DMArrayCopyShortTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayCopyShortTest extends Thread {

   private short [] privateArray;
   public static Object lock;

   public DMArrayCopyShortTest(int num) {
      privateArray = new short[num];
   }

   private native void nSetArray(short [] srcArray, short [] dstArray);

   public void setArray(short [] srcArray) {
	this.nSetArray(srcArray, this.privateArray);
   }

   public short getArrayElement(int index) {
      return(privateArray[index]);
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      System.out.println();

      short [] shortArray = new short[arrayLength];
      for(int i=0; i<arrayLength; i++)
         shortArray[i] = (short) rd.nextInt();

      setArray(shortArray);

      for(int i=0; i<arrayLength; i++) {
         if(getArrayElement(i) != shortArray[i]) {
            pass = false;	
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayCopyShortTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayCopyShortTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayCopyShortTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayCopyShortTest test = new DMArrayCopyShortTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
