/*
 * @(#)DMArrayRWBodyShortTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayRWBodyShortTest extends Thread {

   private short [] privateArray;
   public static Object lock;

   public DMArrayRWBodyShortTest(int num) {
      privateArray = new short[num];
   }

   private native void nSetArray(short[] dstArray, short[] srcArray, int arrayLength);

   public void setArray(short [] srcArray) {
        this.nSetArray(this.privateArray, srcArray, getArrayLength());
   }

   public short [] getArray() {
      int arrLength = getArrayLength();
      short [] shortArray = new short[arrLength];

      for(int i=0; i<arrLength; i++)
         shortArray[i] = privateArray[i];

       return shortArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      short [] inArray = new short[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = (short) rd.nextInt();

      setArray(inArray);
      short [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(inArray[i] != outArray[i]) {
            pass = false;
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayRWBodyShortTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayRWBodyShortTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayRWBodyShortTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayRWBodyShortTest test = new DMArrayRWBodyShortTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
