/*
 * @(#)DMArrayRWBooleanTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMArrayRWBooleanTest extends Thread {

   private boolean [] privateArray;
   public static Object lock;

   public DMArrayRWBooleanTest(int num) {
      privateArray = new boolean[num];
   }

   private native void nSetArray(boolean [] dstArray, boolean [] srcArray, int arrayLength);

   public void setArray(boolean [] boolArray) {
	this.nSetArray(this.privateArray, boolArray, getArrayLength());
   }

   public boolean [] getArray() {
      int arrLength = getArrayLength();
      boolean [] boolArray = new boolean[arrLength];

      for(int i=0; i<arrLength; i++)
         boolArray[i] = privateArray[i];

       return boolArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      boolean [] inArray = new boolean[arrayLength];
      for(int i=0; i<arrayLength; i++) {
         if(i%2 == 0)
            inArray[i] = true;
         else
            inArray[i] = false;
      }

      setArray(inArray);
      boolean [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(outArray[i] != inArray[i]) {
            pass = false;       
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMArrayRWBooleanTest, Data written and read were same");
      else
         System.out.println("FAIL: DMArrayRWBooleanTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      Random rd = new Random();
      Object lck = new Object();

      DMArrayRWBooleanTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMArrayRWBooleanTest test = new DMArrayRWBooleanTest(rd.nextInt(100));

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}
