/*
 * @(#)DMFieldRWFloatTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class DMFieldRWFloatTest extends Thread {

   public float cvar;
   private float evar;
   protected float dvar;
   public static Object lock;

   public DMFieldRWFloatTest() {
      cvar = 0.0f;
      evar = 0.0f;
      dvar = 0.0f;
   }

   public native void nSetValues(float v1, float v2, float v3);

   public native float [] nGetValues();

   public float [] getValues() {
      float [] floatArray = {cvar, evar, dvar};
      return floatArray;
   }

   public void run() {
      boolean pass=true;
      Random rd = new Random();
      float [] var = {rd.nextFloat(), rd.nextFloat(), rd.nextFloat()};

      System.out.println();

      nSetValues(var[0], var[1], var[2]);

      System.out.println();

      float [] floatArray1 = getValues();
      float [] floatArray2 = nGetValues();

      if(floatArray1.length == floatArray2.length) {
         for(int i=0; i<floatArray1.length; i++) {
            if(floatArray1[i] != floatArray2[i]) {
               pass = false;	
               break;
            }
         }
      }
      else {
         pass = false;
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: DMFieldRWFloatTest, Data written and read were same");
      else
         System.out.println("FAIL: DMFieldRWFloatTest, Data written and read were not same");

   }

   
   public static void main(String args[]) {
      Object lck = new Object();

      DMFieldRWFloatTest.lock = lck;
      GcThread.lock = lck;

      GcThread gc = new GcThread();
      DMFieldRWFloatTest test = new DMFieldRWFloatTest();

      gc.setPriority(test.getPriority() + 1);
      gc.start();
      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      gc.interrupt();
   }

}

