/*
 * @(#)IDArrayRWByteTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class IDArrayRWByteTest extends Thread {

   private byte [] privateArray;

   public IDArrayRWByteTest(int num) {
      privateArray = new byte[num];
   }

   private native void nSetArray(byte [] dstArray, byte [] srcArray, int arrayLength);

   public void setArray(byte [] byteArray) {
	this.nSetArray(this.privateArray, byteArray, getArrayLength());
   }

   public byte [] getArray() {
      int arrLength = getArrayLength();
      byte [] byteArray = new byte[arrLength];

      for(int i=0; i<arrLength; i++)
         byteArray[i] = privateArray[i];

       return byteArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      byte [] inArray = new byte[arrayLength];
      rd.nextBytes(inArray);

      setArray(inArray);
      byte [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(outArray[i] != inArray[i]) {
            pass = false;       
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: IDArrayRWByteTest, Data written and read were same");
      else
         System.out.println("FAIL: IDArrayRWByteTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      int numGcThreads = 10;
      Random rd = new Random();

      IDArrayRWByteTest test = new IDArrayRWByteTest(rd.nextInt(100));

      GcThread.sleepCount = numGcThreads;
      GcThread [] gc = new GcThread[numGcThreads];
      for(int i=0; i<gc.length; i++) {
         gc[i] = new GcThread();
         gc[i].start();
      }

      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      for(int i=0; i<gc.length; i++) {
         gc[i].interrupt();
      }

      try {
         for(int i=0; i<gc.length; i++) {
            gc[i].join();
         }
      } catch (Exception e) {}
   }

}
