/*
 * @(#)IDArrayRWCharTest.java	1.1 00/06/14
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import java.util.Random;

public class IDArrayRWCharTest extends Thread {

   private char [] privateArray;

   public IDArrayRWCharTest(int num) {
      privateArray = new char[num];
   }

   private native void nSetArray(char [] dstArray, char [] srcArray, int arrayLength);

   public void setArray(char [] charArray) {
	this.nSetArray(this.privateArray, charArray, getArrayLength());
   }

   public char [] getArray() {
      int arrLength = getArrayLength();
      char [] charArray = new char[arrLength];

      for(int i=0; i<arrLength; i++)
         charArray[i] = privateArray[i];

       return charArray;
   }

   public int getArrayLength() {
	return this.privateArray.length;
   }

   public void run() {
      int arrayLength;
      boolean pass=true;
      Random rd = new Random();

      arrayLength = getArrayLength();

      char [] inArray = new char[arrayLength];
      for(int i=0; i<arrayLength; i++)
         inArray[i] = Character.forDigit(rd.nextInt(Character.MAX_RADIX), Character.MAX_RADIX);

      setArray(inArray);
      char [] outArray = getArray();

      for(int i=0; i<arrayLength; i++) {
         if(outArray[i] != inArray[i]) {
            pass = false;       
            break;
         }
      }

      System.out.println();

      if(pass)
         System.out.println("PASS: IDArrayRWCharTest, Data written and read were same");
      else
         System.out.println("FAIL: IDArrayRWCharTest, Data written and read were not same");
   }
   
   public static void main(String args[]) {
      int numGcThreads = 10;
      Random rd = new Random();

      IDArrayRWCharTest test = new IDArrayRWCharTest(rd.nextInt(100));

      GcThread.sleepCount = numGcThreads;
      GcThread [] gc = new GcThread[numGcThreads];
      for(int i=0; i<gc.length; i++) {
         gc[i] = new GcThread();
         gc[i].start();
      }

      test.start();

      try {
         test.join();
      } catch (Exception e) {}

      for(int i=0; i<gc.length; i++) {
         gc[i].interrupt();
      }

      try {
         for(int i=0; i<gc.length; i++) {
            gc[i].join();
         }
      } catch (Exception e) {}
   }
}
