/*
 * @(#)SerializationTestClient.java	1.4 00/07/28
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
package foundation;

import java.net.Socket;
import java.io.OutputStream;
import java.io.ObjectOutputStream;
import foundation.SerializationTestObject;

/** Connects to a SerializationTestServer and sends two objects (a
    String array and a custom object) to it to be printed. */

public class SerializationTestClient {
    public static void usage() {
	System.out.println("java SerializationTestClient [server name]");
    }

    public static void main(String[] args) {
	try {
	    if (args.length != 1) {
		usage();
		return;
	    }
	    Socket sock = new Socket(args[0], 13913);
	    OutputStream outStr = sock.getOutputStream();
	    ObjectOutputStream objOutStr = new ObjectOutputStream(outStr);
	    String[] strs = new String[3];
	    strs[0] = "Hello,";
	    strs[1] = "serialized";
	    strs[2] = "world!";
	    System.out.println("Writing string array...");
	    objOutStr.writeObject(strs);
	    SerializationTestObject obj = new SerializationTestObject();
	    obj.booleanField = true;
	    obj.byteField = 4;
	    obj.charField = 'L';
	    obj.shortField = 17;
	    obj.intField = 39;
	    obj.floatField = 5.0f;
	    obj.longField = 8000000000001L; // 2^33 + 1
	    obj.doubleField = 7.0f;
	    System.out.println("Writing SerializationTestObject...");
	    objOutStr.writeObject(obj);
	    System.out.println("Flushing ObjectOutputStream...");
	    objOutStr.flush();
	    System.out.println("Closing socket...");
	    sock.close();
	    System.out.println(
	        "SerializationTestClient exiting successfully."
	    );
	}
	catch (Exception e) {
	    e.printStackTrace();
	    System.out.println(
	        "ERROR: SerializationTestClient exiting unsuccessfully."
	    );
	}
    }
}
