/*
 * @(#)SerializationTestServer.java	1.4 00/07/28
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
package foundation;

import java.net.Socket;
import java.net.ServerSocket;
import java.io.InputStream;
import java.io.ObjectInputStream;
import foundation.SerializationTestObject;

/** Receives connection from a SerializationTestClient and receives
    and prints two objects (a String array and a custom object). */

public class SerializationTestServer {
    public static void main(String[] args) {
	try {
	    System.out.println("Waiting for connection from " +
			       "SerializationTestClient...");
	    ServerSocket serv = new ServerSocket(13913);
	    Socket sock = serv.accept();
	    InputStream inStr = sock.getInputStream();
	    ObjectInputStream objInStr = new ObjectInputStream(inStr);
	    String[] strs = (String[]) objInStr.readObject();
	    System.out.println("Received " + strs.length + " strings:");
	    for (int i = 0; i < strs.length; i++) {
		System.out.println("String " + i + ": " + strs[i]);
	    }
	    SerializationTestObject obj =
		(SerializationTestObject) objInStr.readObject();
	    System.out.println("Received SerializationTestObject:\n" + obj);
	    System.out.println("Closing sockets...");
	    sock.close();
	    serv.close();
	    System.out.println(
	        "SerializationTestServer exiting successfully."
	    );
	}
	catch (Exception e) {
	    e.printStackTrace();
	    System.out.println(
	        "ERROR: SerializationTestServer exiting unsuccessfully."
	    );
	}
    }
}
