/*
 * @(#)CVMInitInfo.java	1.3 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
package runtime;

class CVMInitInfo {
    /*
     * This is just a tripl of:
     *     from-address
     *     to-address
     *     byte count
     * that get stuffed in an array-of-triples
     * for interpretation by the startup code.
     */
    String fromAddress;
    String toAddress;
    String byteCount;
    CVMInitInfo next;

    CVMInitInfo( String f, String t, String c, CVMInitInfo n ){
	fromAddress = f;
	toAddress = t;
	byteCount = c;
	next = n;
    }

    static CVMInitInfo initList = null;

    public static void
    addInfo( String f, String t, String c ){
	initList = new CVMInitInfo( f, t, c, initList );
    }

    public static void
    write( CCodeWriter out, String typename, String dataname, String nname ){
	int n = 0;
	out.println("const struct "+typename+" "+dataname+"[] = {");
	for ( CVMInitInfo p = initList; p != null; p = p.next ){
	    out.println("    { "+p.fromAddress+", "+p.toAddress+", "+p.byteCount+" },");
	    n++;
	}
	out.println("};");
	out.println("const int "+nname+" = "+n+";");
    }
}
