/*
 * @(#)CVMpkg.java	1.3 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */
package vm;
import java.util.Vector;
/*
 * Package name in CVM type system.
 */

public class CVMpkg {
    public String	pkgName;
    public CVMpkg	next;
    public CVMDataType typeData[];
    public int	        entryNo;

    public final static int NCLASSHASH = 7;
    public final static int NPACKAGEHASH = 17;

    public static Vector pkgVector = new Vector(); // must come before nullPackage!

    public static CVMpkg packages[] = new CVMpkg[NPACKAGEHASH];
    static int    nextPkgNo = 0;

    synchronized static void enlist( CVMpkg x ){
	x.entryNo = nextPkgNo++;
	pkgVector.addElement( x );
    }
    
    CVMpkg( String pname ){
	pkgName = pname;
	next = null;
	typeData = new CVMDataType[NCLASSHASH];
	enlist( this );
    }

    /*
     * order matters. In order to invoke the usual constructor,
     * this seems to have to follow it!!
     */

    public static CVMpkg nullPackage = new CVMpkg( "" );


    public static CVMpkg
    lookup( String pkgname ){
	if ( pkgname.length() == 0 ) return nullPackage;
	pkgname = pkgname.intern();
	long nameHash = CVMDataType.computeHash( pkgname );
	/* make sure % is unsigned! */
	int bucket = (int)((nameHash&0xffffffffL) % (long)NPACKAGEHASH);
	/*DEBUG System.out.println("hash package "+pkgname+" to "+bucket); */

	for ( CVMpkg thisPkg = packages[bucket];
	    thisPkg != null;
	    thisPkg = thisPkg.next )
	{
	    if ( pkgname == thisPkg.pkgName )
		return thisPkg;
	}
	// not there, must add.
	CVMpkg p = new CVMpkg( pkgname );
	p.next = packages[bucket];
	packages[bucket] = p;
	return p;
    }
}

