/*
 * @(#)jlong.h	1.11 00/05/19
 *
 * Copyright 1994-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

#ifndef _JLONG_H_
#define _JLONG_H_

/*
 * JDK-compatability interface
 */

#include "javavm/include/porting/doubleword.h"

#define jlong_zero		CVMlongConstZero()
#define jlong_to_jint		CVMlong2Int
#define jint_to_jlong		CVMint2Long
#define ptr_to_jlong		CVMvoidPtr2Long
#define jlong_to_ptr		CVMlong2VoidPtr
#define jlong_shl(l, b)		((l) = CVMlongShl((l), (b)))

/* 
 * Useful on machines where jlong and jdouble have different endianness.
 */

#if (CVM_DOUBLE_ENDIANNESS == CVM_ENDIANNESS)

#define jlong_to_jdouble_bits(longBitsPtr)
#define jdouble_to_jlong_bits(doubleBitsPtr)

#else

#define jlong_to_jdouble_bits(longBitsPtr)     	\
    CVMlongBitsToDouble(*longBitsPtr, *longBitsPtr)

#define jdouble_to_jlong_bits(doubleBitsPtr)	\
    CVMdoubleToLongBits(*doubleBitsPtr, *doubleBitsPtr); 

#endif

#endif
